-- ARCHIVO CON LAS ACTUALIZACIONES DE DATA DE SQL PARA MIGRAR AL NUEVO BUILD DEL NOMBRE DE LA CARPETA
-- DECLARAMOS DOS VARIABLES, UNA CON LA VERSION DE LA QUE PARTIMOS Y OTRA CON LA NUEVA VERSION QUE ESTAMOS APUNTANDO
DECLARE @OLD_DATABASE_BUILD_VERSION VARCHAR(50) = '0.22.1'
DECLARE @NEW_DATABASE_BUILD_VERSION VARCHAR(50) = '0.23.0'

-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
BEGIN TRY
    -- VALIDAMOS QUE LA VERSION EXISTENTE COINCIDE CON NUESTRA NEW_DATABASE_BUILD_VERSION
    IF NOT EXISTS (
        SELECT 1 
            FROM [dbo].[Version] V 
            WHERE V.[BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    )	
        -- LANZAMOS UN MENSAJE DE ERROR INDICANDO QUE LA VERSION ACTUAL NO COINCIDE CON LA OLD_DATABASE_BUILD_VERSION
        RAISERROR('DATABASE_ERROR_INCORRECT_TARGET_VERSION', 16, 16)
        
    -- INICIAMOS LA TRANSACCION
    BEGIN TRANSACTION





    -- AQUI EMPIEZA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION



                    --INSERTAR LOS CAMPOS DE LOS REPORTES QUE TENDRAN LISTAS DESPLEGABLES
                    INSERT INTO [dbo].[ReportFieldAttribute]([Field],[Label],[IsDisabled],[IsDropdown],[Procedure],[Arguments],[Variables],[CreatedAt])
                    VALUES('@HistoricCampaign','CAMPAIGN',0,1,'GetCampaignsFromEvaluation','VCC,UserId','{"value":"id","description":"description"}',GETUTCDATE())
                    

                    INSERT INTO [dbo].[ReportFieldAttribute]([Field],[Label],[IsDisabled],[IsDropdown],[Procedure],[Arguments],[Variables],[CreatedAt])
                    VALUES('@IdAuditor','AUDITOR',0,1,'GetAuditorsFromEvaluationPlans','VCC','{"value":"idAuditor","description":"idAuditor"}',GETUTCDATE())
                        
                    INSERT INTO [dbo].[ReportFieldAttribute]([Field],[Label],[IsDisabled],[IsDropdown],[Procedure],[Arguments],[Variables],[CreatedAt])
                    VALUES('@IdAgente','AGENT',0,1,'GetAgentsFromHistoricEvaluationPlans','VCC','{"value":"idAgent","description":"idAgent"}',GETUTCDATE())                       

                    INSERT INTO [dbo].[ReportFieldAttribute]([Field],[Label],[IsDisabled],[IsDropdown],[Procedure],[Arguments],[Variables],[CreatedAt])
                    VALUES('@Plan','EVALUATION_PLAN',0,1,'GetEvaluationPlansSummary','VCC','{"value":"description","description":"description"}',GETUTCDATE())  

                    INSERT INTO [dbo].[ReportFieldAttribute]([Field],[Label],[IsDisabled],[IsDropdown],[Procedure],[Arguments],[Variables],[CreatedAt])
                    VALUES('@Format','EVALUATION_FORMAT',0,1,'GetEvaluationFormatsFromHistoricEvaluationPlans','VCC','{"value":"description","description":"description"}',GETUTCDATE())  
                   
                   
                    DECLARE RECURRENT_CURSOR CURSOR 
                    LOCAL STATIC READ_ONLY FORWARD_ONLY
                        FOR 
                        -- SELECCIONAMOS LOS VCC EXISTENTES
                        SELECT [VCC]
                            FROM [dbo].[VCC] (NOLOCK) 

                    -- DECLARARAMOS UNA VARIABLE PARA INDICAR EL CAMPO ACTUAL QUE ESTAMOS ACTUALIZANDO
                    DECLARE @CURRENT_VCC_TO_UPDATE VARCHAR(50) = ''

                    -- ABRIMOS Y RECORREMOS EL ARRAY DE CAMPOS A ACTUALIZAR
                    OPEN RECURRENT_CURSOR
                    FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_VCC_TO_UPDATE
                    WHILE @@FETCH_STATUS = 0
                    BEGIN 



                        --INSERTAR LOS PERMISOS PARA LA API
                        INSERT INTO [dbo].[RoutePermission] ([VCC], [ID], [GroupId], [Route], [Level], [TimeStamp]) 
                        VALUES (@CURRENT_VCC_TO_UPDATE, NEWID(), N'PERM_GROUP_REPORT_VIEW', N'api/report/get_filters_options', N'api', GETUTCDATE())

                       

                        FETCH NEXT FROM RECURRENT_CURSOR INTO @CURRENT_VCC_TO_UPDATE
                    END
                    CLOSE RECURRENT_CURSOR
                    DEALLOCATE RECURRENT_CURSOR
    



    -- AQUI TERMINA LA SECCION CON LOS INSERT/UPDATE/DELETE PARA LA NUEVA VERSION



    

    -- TERMINAMOS LA ACTUALIZACION DE DATA ACTUALIZANDO EL BUILDVERSION
    UPDATE [dbo].[Version] 
        SET [BuildVersion] = @NEW_DATABASE_BUILD_VERSION, 
            [IsRegistered] = 0,
            [TimeStamp] = GETUTCDATE() 
        WHERE [BuildVersion] = @OLD_DATABASE_BUILD_VERSION
    PRINT 'UPDATED_DATABASE_BUILD_VERSION'

    -- COMPLETAMOS LA TRANSACCION
    COMMIT TRANSACTION
END TRY
BEGIN CATCH
    IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

    DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
    DECLARE @Severity integer = ERROR_SEVERITY()
    DECLARE @State integer = ERROR_STATE()

    RAISERROR(@Message, @Severity, @State)
    --RETURN -1
END CATCH



