

GO
PRINT N'Creando [dbo].[ReportFieldAttribute]...';


GO
CREATE TABLE [dbo].[ReportFieldAttribute] (
    [Field]      VARCHAR (50)  NULL,
    [Label]      VARCHAR (50)  NULL,
    [IsDisabled] BIT           NULL,
    [IsDropdown] BIT           NULL,
    [Procedure]  VARCHAR (50)  NULL,
    [Arguments]  VARCHAR (MAX) NULL,
    [Variables]  VARCHAR (MAX) NULL,
    [CreatedAt]  DATETIME      NULL
);


GO
PRINT N'Creando restricción sin nombre en [dbo].[ReportFieldAttribute]...';


GO
ALTER TABLE [dbo].[ReportFieldAttribute]
    ADD DEFAULT ((0)) FOR [IsDisabled];


GO
PRINT N'Creando restricción sin nombre en [dbo].[ReportFieldAttribute]...';


GO
ALTER TABLE [dbo].[ReportFieldAttribute]
    ADD DEFAULT ((0)) FOR [IsDropdown];


GO
PRINT N'Creando restricción sin nombre en [dbo].[ReportFieldAttribute]...';


GO
ALTER TABLE [dbo].[ReportFieldAttribute]
    ADD DEFAULT (getutcdate()) FOR [CreatedAt];


GO
PRINT N'Modificando [dbo].[GetCampaignsFromEvaluation]...';


GO
-- ESTE SP RETORNA LAS CAMPANAS ASOCIADAS A EVALUACIONES
ALTER PROCEDURE [dbo].[GetCampaignsFromEvaluation] 
(
	@VCC					VARCHAR(50) = NULL,
	@UserId					VARCHAR(50) = NULL,
	@SearchType				VARCHAR(50) = 'HISTORY'
) 
AS
BEGIN
	-- DECLARAMOS UN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT += '
		SELECT DISTINCT IEP.[Instance]							''vcc'', 
						IEP.[IdCampaign]						''id'',
						IEP.[IdCampaign]						''description'' '

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
			INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				ON IEP.[Instance] = AEP.[Instance]
					AND IEP.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND IEP.[IdInteraction] = AEP.[IdInteraction] '

	-- ARMAMOS LA PARTE DE FILTROS
	SET @SQL_FILTER += '
			WHERE AEP.[Instance] = ''' + @VCC + ''' '

	-- ARMAMOS LA PARTE DE EXTRAS
	SET @SQL_EXTRA = '
			ORDER BY IEP.[IdCampaign] ASC '

	-- FILTRAMOS SEGUN EL TIPO DE BUSQUEDA
	IF @SearchType = 'PENDING'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES QUE NO HAN SIDO EVALUADAS
		SET @SQL_FILTER += '
			AND AEP.[Completed] = 0 '
	END
	ELSE IF @SearchType = 'HISTORY'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES QUE YA HAN SIDO EVALUADAS
		SET @SQL_FILTER += '
			AND AEP.[Completed] = 1 '
	END

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL ROLE DEL USUARIO
	DECLARE @USER_ROLE VARCHAR(50) 
	SELECT TOP 1 @USER_ROLE = U.[Role] 
		FROM [dbo].[User] U (NOLOCK) 
		WHERE U.[VCC] = @VCC
			AND U.[ID] = @UserId

	-- FILTRAMOS SEGUN EL ROLE DEL USUARIO
	-- IF @RoleId = 'administrator, quality_admin'
	IF @USER_ROLE = 'quality_auditor'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES AUDITADAS POR EL USUARIO
		SET @SQL_FILTER += '
			AND AEP.[IdAuditor] = ''' + @UserId + ''' '
	END
	ELSE IF @USER_ROLE = 'quality_agent'
	BEGIN
		-- HACEMOS LA BUSQUEDA SOBRE LAS INTERACCIONES HECHAS POR EL USUARIO
		SET @SQL_FILTER += '
			AND AEP.[IdAgent] = ''' + @UserId + ''' '
	END

	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA
	
	-- EJECUTAMOS LA CONSULTA
	EXEC (@SQL_SELECT)
	
END
GO
PRINT N'Modificando [dbo].[GetCleanerData]...';


GO


ALTER PROCEDURE [dbo].[GetCleanerData] (
@VCC VARCHAR(50),
@DAYS INT
)

AS
BEGIN
	SET NOCOUNT ON
      
				      --BUSCA REGISTROS PARA ELIMINARLOS DE LA BASE DE DATOS POR CADA VCC
				      
				
					   DECLARE @NOW VARCHAR(15) = CONVERT(VARCHAR,GETUTCDATE(),23)
				
					   CREATE TABLE #ProcessToDelete(
					   [Name] VARCHAR(50)
					   )
				       
				       CREATE TABLE #ProcessAsyncToDelete(
				       [ProcessId]  VARCHAR(50)
				       )
				       
				       DECLARE @FindInEvaluationPlan TABLE (
				        [Name] VARCHAR(50)
				       )
				       
				       DECLARE @FindInStudy TABLE (
				        [Name] VARCHAR(50)
				       )	
				       
					   DECLARE @EvaluationPlan TABLE(
					   [ID]      VARCHAR(50)
					   )
					   DECLARE @Study TABLE(
					   [Name]    VARCHAR(50)
					   )

					   CREATE TABLE #AudioToDelete(
					   [ID]       VARCHAR(100),
					   [FileName] VARCHAR(700)
					   )
					   
					   CREATE TABLE #AsyncInteractionToDelete(
					   [ID]       VARCHAR(250)
					   )
					   
					 --BUSCAR PLANES
					 
					  INSERT INTO @EvaluationPlan
					  SELECT 
							[ID]
					  FROM  [dbo].[EvaluationPlan] (NOLOCK) 
					  WHERE [Instance] = @VCC 
							AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) > @DAYS

					--BUSCAR ESTUDIOS
					
					INSERT INTO @Study
					SELECT 
					    
						  [Name]
				    FROM  [dbo].[Study] (NOLOCK)
					WHERE [VCC] = @VCC
					      AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) > @DAYS
					      
					  
					--BUSCAR PROCESOS DE PLANES
					
			       INSERT INTO #ProcessToDelete 
				   SELECT 
					     P.[Name]
				   FROM  [dbo].[Process] P (NOLOCK) 
				   JOIN  [dbo].[EvaluationPlan] EP (NOLOCK)
				         ON (P.[VCC] = EP.[Instance] AND P.[Name] = EP.[ProcessId] )
				   WHERE P.[VCC] = @VCC 
				         AND EP.[ID] IN (SELECT [ID] FROM @EvaluationPlan)
				         
				         
				    --BUSCAR SI SE ESTA UTILIZANDO EN PLANES MAS RECIENTES
				    
				    INSERT INTO @FindInEvaluationPlan
				    SELECT 
				         DISTINCT [ProcessId]
				    FROM [dbo].[EvaluationPlan] (NOLOCK)
				    WHERE [Instance] = @VCC 
				         -- AND [ProcessId] IN (SELECT [Name] FROM #ProcessToDelete)
				          AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) <= @DAYS
				          
	

					--BUSCAR PROCESOS DE ESTUDIOS
					
			       INSERT INTO #ProcessToDelete 
				   SELECT 
					     P.[Name]
				   FROM  [dbo].[Process] P (NOLOCK) 
				   JOIN  [dbo].[Study] S (NOLOCK)
				         ON (P.[VCC] = S.[VCC] AND P.[Name] = S.[ProcessId] )
				   WHERE P.[VCC] = @VCC 
				         AND S.[Name] IN (SELECT [Name] FROM @Study)
				         

				    --BUSCAR SI SE ESTA UTILIZANDO EN ESTUDIOS MAS RECIENTES
				    
				    INSERT INTO @FindInStudy
				    SELECT 
				         DISTINCT [ProcessId]
				    FROM [dbo].[Study] (NOLOCK)
				    WHERE [VCC] = @VCC 
				          --AND [ProcessId] IN (SELECT [Name] FROM #ProcessToDelete)
				          AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) <= @DAYS
				          
				     
				          
 					--BUSCAR PROCESOS QUE NO ESTEN ASIGNADOS
					
			       INSERT INTO #ProcessToDelete 
				   SELECT 
					     [Name]
				   FROM  [dbo].[Process] (NOLOCK) 
				   WHERE [VCC] = @VCC 
				         AND [Name] NOT IN (SELECT [Name] FROM #ProcessToDelete)
				         AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) > @DAYS
				         
				         
				    --ELIMINAR DE #ProcessToDelete LOS PROCESOS QUE SE ASIGNARON MAS DE UNA VEZ Y RECIENTEMENTE
				    
				     DELETE FROM #ProcessToDelete WHERE [Name] IN (SELECT [Name] FROM @FindInEvaluationPlan)
				     DELETE FROM #ProcessToDelete WHERE [Name] IN (SELECT [Name] FROM @FindInStudy)  
				     

                    --BUSCAR AUDIOS DE LOS PROCESOS QUE QUEDARON PARA SER ELIMINADOS
                    
                    INSERT INTO #AudioToDelete
                    SELECT A.[ID],A.[FileName] FROM [dbo].[Audio] A (NOLOCK)
                    JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
                    ON (A.[VCC] = PA.[VCC] AND A.[ID] = PA.[AudioId])
                    WHERE A.[VCC] = @VCC 
                          AND  PA.[ProcessId] IN (SELECT [Name] FROM #ProcessToDelete)
                    
                    --BUSCAR Y QUITAR LOS AUDIOS QUE FUERON ASIGNADOS A UN NUEVO PROCESO
                    
                     DELETE FROM #AudioToDelete 
                     WHERE [ID] IN (
                     SELECT [ID] FROM [dbo].[Audio] A (NOLOCK) 
                     JOIN [dbo].[ProcessAudio] PA (NOLOCK)
                     ON (A.[VCC] = PA.[VCC] AND A.[ID] = PA.[AudioId])
                     WHERE A.[VCC] = @VCC
                          AND  PA.[ProcessId] NOT IN (SELECT [Name] FROM #ProcessToDelete)
                          AND DATEDIFF(DAY,CONVERT(VARCHAR,PA.[CreatedDate],23),@NOW) <= @DAYS
                     )
                     
                     
                    --RESETEAR VARIABLES TEMPORALES PARA UTILIZARLAS CON PROCESOS ASINCRONOS
                    
                    DELETE FROM @FindInEvaluationPlan
                    DELETE FROM @FindInStudy
                    
                    
                    --BUSCAR PROCESOS ASINCRONOS DE PLANES
                     INSERT INTO #ProcessAsyncToDelete
                     SELECT 
					     P.[ProcessId]
				     FROM  [dbo].[ProcessAsyncInteraction] P (NOLOCK) 
				     JOIN  [dbo].[EvaluationPlan] EP (NOLOCK)
				         ON (P.[VCC] = EP.[Instance] AND P.[ProcessId] = EP.[ProcessId] )
				     WHERE P.[VCC] = @VCC 
				         AND EP.[ID] IN (SELECT [ID] FROM @EvaluationPlan)    
				         
				         
				    --BUSCAR PROCESOS ASINCRONOS SI SE ESTA UTILIZANDO EN PLANES MAS RECIENTES
				    
				    INSERT INTO @FindInEvaluationPlan
				    SELECT 
				         [ProcessId]
				    FROM  [dbo].[EvaluationPlan] (NOLOCK)
				    WHERE [Instance] = @VCC 
				          --AND [ProcessId] IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
				          AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) <= @DAYS
				          

					--BUSCAR PROCESOS ASINCRONOS DE ESTUDIOS
					
			       INSERT INTO #ProcessAsyncToDelete 
				   SELECT 
					     P.[ProcessId]
				   FROM  [dbo].[ProcessAsyncInteraction] P (NOLOCK) 
				   JOIN  [dbo].[Study] S (NOLOCK)
				         ON (P.[VCC] = S.[VCC] AND P.[ProcessId] = S.[ProcessId] )
				   WHERE P.[VCC] = @VCC 
				         AND S.[Name] IN (SELECT [Name] FROM @Study)
				         
				         
				    --BUSCAR PROCESOS ASINCRONOS SI SE ESTA UTILIZANDO EN ESTUDIOS MAS RECIENTES
				    
				    INSERT INTO @FindInStudy
				    SELECT 
				         DISTINCT [ProcessId]
				    FROM [dbo].[Study]  (NOLOCK)
				    WHERE [VCC] = @VCC 
				          --AND [ProcessId] IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
				          AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) <= @DAYS
				          
				     
 					--BUSCAR PROCESOS ASINCRONOS QUE NO ESTEN ASIGNADOS A PLANES NI ESTUDIOS
					
			       INSERT INTO #ProcessAsyncToDelete 
				   SELECT 
					     [ProcessId]
				   FROM  [dbo].[ProcessAsyncInteraction] (NOLOCK) 
				   WHERE [VCC] = @VCC 
				         AND [ProcessId] NOT IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
				         AND DATEDIFF(DAY,CONVERT(VARCHAR,[CreatedDate],23),@NOW) > @DAYS
				         
				    --ELIMINAR DE #ProcessAsyncToDelete LOS PROCESOS QUE SE ASIGNARON MAS DE UNA VEZ Y RECIENTEMENTE
				    
				     DELETE FROM #ProcessAsyncToDelete WHERE [ProcessId] IN (SELECT [ProcessId] FROM @FindInEvaluationPlan)
				     DELETE FROM #ProcessAsyncToDelete WHERE [ProcessId] IN (SELECT [ProcessId] FROM @FindInStudy)  
				     

                    --BUSCAR INTERACCIONES ASINCRONAS DE LOS PROCESOS QUE QUEDARON PARA SER ELIMINADOS
                    
                    INSERT INTO #AsyncInteractionToDelete
                    SELECT 
                          A.[ID]
                    FROM [dbo].[AsyncInteraction] A (NOLOCK)
                    JOIN [dbo].[ProcessAsyncInteraction] PA (NOLOCK) 
                    ON (A.[VCC] = PA.[VCC] AND A.[ID] = PA.[InteractionId])
                    WHERE A.[VCC] = @VCC 
                          AND  PA.[ProcessId] IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
                    
                    --BUSCAR Y QUITAR LAS INTERACCIONES ASINCRONAS QUE FUERON ASIGNADAS A UN NUEVO PROCESO
                    
                     DELETE FROM #AsyncInteractionToDelete 
                     WHERE [ID] IN (
                     SELECT [ID] FROM [dbo].[AsyncInteraction] A (NOLOCK) 
                     JOIN [dbo].[ProcessAsyncInteraction] PA (NOLOCK)
                     ON (A.[VCC] = PA.[VCC] AND A.[ID] = PA.[InteractionId])
                     WHERE A.[VCC] = @VCC
                          AND  PA.[ProcessId] NOT IN (SELECT [ProcessId] FROM #ProcessAsyncToDelete)
                          AND DATEDIFF(DAY,CONVERT(VARCHAR,PA.[CreatedDate],23),@NOW) <= @DAYS
                     )
                     
                     
                    --LISTAR LOS RESULTADOS FINALES
                    
                    SELECT [ID] 'id'     FROM @EvaluationPlan
                    
                    SELECT [Name] 'name' FROM @Study
                  
					SELECT DISTINCT [Name] 'name' FROM #ProcessToDelete
					
					SELECT DISTINCT [ProcessId] 'processId' FROM #ProcessAsyncToDelete
					
					SELECT DISTINCT [ID] 'id',[FileName] 'fileName' FROM #AudioToDelete
					
					SELECT DISTINCT [ID] 'id' FROM #AsyncInteractionToDelete
					
					
					--ELIMINAR LAS TABLAS TEMPORALES
					
					DROP TABLE #ProcessToDelete
					DROP TABLE #AudioToDelete
					DROP TABLE #ProcessAsyncToDelete
					DROP TABLE #AsyncInteractionToDelete
	  
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationPlansSummary]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationPlansSummary] (
	@VCC Varchar(50) = NULL,
	@IdAuditor Varchar(50) = NULL,
	@IdAgent Varchar(50) = NULL,
	@Campaigns VARCHAR(MAX) = NULL,
	@EndDate Varchar(50) = NULL,
	@EvaluationFormats Varchar(MAX) = NULL,
	@Modalities Varchar(MAX) = NULL,
	@Completed Bit = 1
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_2 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM_2 VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER_2 VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA_2 VARCHAR(MAX) = '';

	SET @SQL_SELECT_1 += '
		SELECT EP.[ID]																	''id'',
				EP.[Modality]															''modality'',
				EP.[DateFin]															''dateFin'',
				EP.[CreatedDate]														''createdDate'',
				EP.[IdEvaluationFormat]													''idEvaluationFormat'',
				EP.[Description]														''description'',
				COUNT(CASE AEP.Completed WHEN 0 THEN 1 ELSE NULL END)					''pendingInteractionCount'',
				COUNT(AEP.Completed)													''completedCount'',
				SUM(AEP.InteractionDuration)											''interactionTimeSum'',
				SUM(CASE AEP.Completed WHEN 0 THEN AEP.InteractionDuration ELSE 0 END)	''pendingInteractionTimeSum'' ';

	SET @SQL_FROM += '
			FROM [EvaluationPlan] EP (NOLOCK)
			LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
				ON (AEP.[Instance] = ''' + @VCC + ''' ';

	IF (@IdAuditor IS NOT NULL AND @IdAuditor <> '') SET @SQL_FROM += 'AND AEP.[IdAuditor] = ''' + @IdAuditor + ''' '

	IF (@IdAgent IS NOT NULL AND @IdAgent <> '') SET @SQL_FROM += 'AND AEP.[IdAgent] = ''' + @IdAgent + ''' '

	SET @SQL_FROM += ')';

	SET @SQL_FILTER += '
			WHERE EP.[Instance] = ''' + @VCC + '''
				AND AEP.[IdEvaluationPlan] = EP.[ID]
				AND EP.[Enabled] = 1 ';
				
				
    IF (@EndDate IS NOT NULL AND @EndDate <> '')
    BEGIN 
       SET @SQL_FILTER +=' AND EP.[DateFin] <= ''' + @EndDate + ''''
    END

	IF (@Campaigns IS NOT NULL AND @Campaigns <> '')
	BEGIN
		SET @SQL_FILTER += '
				AND EP.[IdEvaluationFormat] IN ( 
					SELECT CEF.[IdEvaluationFormat] FROM CampaignEvaluationFormat CEF (NOLOCK)
						WHERE CEF.[Instance] = ''' + @VCC + '''
							AND CEF.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','',''))) '
	END;

	IF (@EvaluationFormats IS NOT NULL AND @EvaluationFormats <> '') SET @SQL_FILTER += 'AND EP.[IdEvaluationFormat] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationFormats + ''','','')) ';
	IF (@Modalities IS NOT NULL AND @Modalities <> '') SET @SQL_FILTER += 'AND EP.[Modality] IN (SELECT Value FROM [dbo].[split](''' + @Modalities + ''','','')) ';
	
	IF (@Completed = 1)
	BEGIN
		SET @SQL_FILTER += 'AND AEP.[Completed] = 1 ';
		SET @SQL_FILTER_2 = ' ';	
	END
	ELSE 
	BEGIN
		SET @SQL_FILTER += 'AND AEP.[Completed] = 0 ';
		SET @SQL_FILTER_2 = 'WHERE X.[pendingInteractionCount] > 0 ';
	END;
	

	SET @SQL_EXTRA += '
			GROUP BY EP.[ID],
						EP.[Modality],
						EP.[DateFin],
						EP.[CreatedDate],
						EP.[IdEvaluationFormat],
						EP.[Description]';

	SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA;

	--SET @SQL_SELECT_1 = 'SELECT * FROM (' + @SQL_SELECT_1 + ') AS X WHERE X.[pendingInteractionCount] > 0 ORDER BY X.[Description] ASC; ';
	SET @SQL_SELECT_2 = 'SELECT * ';
	SET @SQL_FROM_2 = 'FROM (' + @SQL_SELECT_1 + ') AS X ';
	-- @SQL_FILTER_2 YA FUE DEFINIDO SEGUN SE BUSCAN LAS YA EVALUADAS O NO EVALUADAS
	SET @SQL_EXTRA_2 = 'ORDER BY X.[Description] ASC;';

	SET @SQL_SELECT_2 += @SQL_FROM_2 + @SQL_FILTER_2 + @SQL_EXTRA_2;


	EXEC (@SQL_SELECT_2);
	
	SET NOCOUNT OFF
	
END;
GO
PRINT N'Modificando [dbo].[GetReportProcedureParameters]...';


GO
ALTER PROCEDURE [dbo].[GetReportProcedureParameters](
	@Procedure Varchar(200)
	)
AS
BEGIN
	SET NOCOUNT ON

    DECLARE 
        @object_id INT,
        @paramID INT,
        @paramName SYSNAME,
        @definition NVARCHAR(MAX),
        @t NVARCHAR(MAX),
        @loc1 INT,
        @loc2 INT,
        @loc3 INT,
        @loc4 INT,
        @has_default_value BIT;

    SET @object_id = OBJECT_ID(@Procedure);

    IF (@object_id IS NOT NULL)
    BEGIN
    
        SELECT @definition = OBJECT_DEFINITION(@object_id);

        CREATE TABLE #params
        (
            parameter_id        INT PRIMARY KEY,
            has_default_value    BIT NOT NULL DEFAULT (0)
        );

        DECLARE c CURSOR
        LOCAL FORWARD_ONLY STATIC READ_ONLY
        FOR 
            SELECT 
                parameter_id,
                [name]
            FROM
                sys.parameters
            WHERE
                [object_id] = @object_id;

        OPEN c;

        FETCH NEXT FROM c INTO @paramID, @paramName;

        WHILE (@@FETCH_STATUS = 0)
        BEGIN
    
            SELECT
                @t = SUBSTRING
                (
                    @definition,
                    CHARINDEX(@paramName, @definition),
                    4000
                ),
                @has_default_value = 0;
            
            SET @loc1 = COALESCE(NULLIF(CHARINDEX('''', @t), 0), 4000);
            SET @loc2 = COALESCE(NULLIF(CHARINDEX(',', @t), 0), 4000);
            SET @loc3 = NULLIF(CHARINDEX('OUTPUT', @t), 0);
            SET @loc4 = NULLIF(CHARINDEX('AS', @t), 0);
            
            SET @loc1 = CASE WHEN @loc2 < @loc1 THEN @loc2 ELSE @loc1 END;
            SET @loc1 = CASE WHEN @loc3 < @loc1 THEN @loc3 ELSE @loc1 END;
            SET @loc1 = CASE WHEN @loc4 < @loc1 THEN @loc4 ELSE @loc1 END;
            
            IF CHARINDEX('=', LTRIM(RTRIM(SUBSTRING(@t, 1, @loc1)))) > 0
                SET @has_default_value = 1;

            INSERT #params
            (
                parameter_id,
                has_default_value
            )
            SELECT
                @paramID,
                @has_default_value;
            
            FETCH NEXT FROM c INTO @paramID, @paramName;
        END
        
        SELECT 
            sp.[name]						'parameter',
            --sp.[parameter_id]				'ordinal',
            st.[name]						'type',
           --sp.[max_length]				'maxLength',
           --sp.[precision]					'precission',
           --sp.[scale]						'scale',
           --sp.[is_output]					'isOutput',
            p.[has_default_value]			'hasDefaultValue',
            IIF(RFA.[Label] IS NULL,REPLACE(sp.[name],'@',''),RFA.[Label])               'label',
            IIF(RFA.[IsDisabled] IS NULL,CAST(0 AS BIT),RFA.[IsDisabled])                'isDisabled',
            IIF(RFA.[IsDropdown] IS NULL,CAST(0 AS BIT),RFA.[IsDropdown])                'isDropdown',
            RFA.[Procedure]                 'procedure',
            RFA.[Arguments]                 '_arguments',
            RFA.[Variables]                 'variables'
        FROM
            sys.parameters sp
        INNER JOIN
            #params p
        ON
            sp.parameter_id = p.parameter_id
        INNER JOIN
            sys.types st
        ON
            sp.user_type_id = st.user_type_id
        LEFT JOIN 
                [dbo].[ReportFieldAttribute] RFA (NOLOCK)
         ON RFA.[Field] =  sp.[name]
        
        WHERE
            sp.[object_id] = @object_id;
        
        CLOSE c;
        DEALLOCATE c;
        DROP TABLE #params;
    END
END
GO
PRINT N'Modificando [dbo].[ReportByDetailAgent]...';


GO


ALTER PROCEDURE [dbo].[ReportByDetailAgent] (
	@VCC varchar(50) = NULL, 
	@HistoricCampaign varchar(50) = NULL , 
	@Plan varchar(50) = NULL,
	@Format varchar(50), 
	@StartDate DateTime = NULL , 
	@EndDate DateTime = NULL , 
	@IdAuditor varchar(50) = NULL ,
	@IdAgente varchar(50) = NULL
) AS
  DECLARE @cols varchar(max) 
  DECLARE @query varchar(max)
  
  -- ReportByDetailAgent 'allegro','entrantes','Plan_2_nov01-0356','nov01-0356','20191001','20191201','isidoro','icagente3'
  SET NOCOUNT ON

  SELECT
    * INTO #TempEvaluationResult
  FROM (
  SELECT
	EP.[Instance]														'VCC',
    EP.Description														AS 'DescriptionPlan',
    EF.Description														AS 'DescriptionFormat',
    (
		GP.Description
		+ '-' 
		+ SGP.Description
		+ '-' 
		+ A.Title
	)																	AS 'Ability', --Collate SQL_Latin1_General_CP1253_CI_AI
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ISNULL(ER.Qualification, 0)											AS 'Qualification',
	AEP.[AutomaticScore],
	AEP.[ManualScore],
	--Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss')					AS 'EvaluationDate',
	--CAST(Format(AEP.[TimeStamp], 'yyyy-MM-dd hh:mm:ss') AS DATETIME)					AS 'EvaluationDate',
	AEP.[TimeStamp] AS 'EvaluationDate',
    ER.IdAuditor,
	EP.Evaluation_Mode	
  FROM EvaluationResult (NOLOCK) ER
  INNER JOIN EvaluationFormat EF
    ON ER.IdEvaluationFormat = EF.ID
  INNER JOIN Ability (NOLOCK) A
    ON A.[Instance] = ER.[Instance]
		AND A.ID = ER.IdAbility
  INNER JOIN EvaluationPlan (NOLOCK) EP
    ON EP.ID = ER.IdEvaluationPlan
	INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
		ON AEP.[Instance] = ER.[Instance]
			AND AEP.[IdEvaluationPlan] =  ER.[IdEvaluationPlan]
			AND AEP.[IdInteraction] = ER.[IdInteraction]
			AND AEP.[IdAuditor] =  ER.[IdAuditor]
  LEFT JOIN [Group] (NOLOCK) GP
    ON GP.ID = ER.IdGroup
  LEFT JOIN SubGroup (NOLOCK) SGP
    ON SGP.ID = ER.IdSubGroup
  WHERE 
	ER.Instance LIKE CASE
		WHEN @VCC IS NOT NULL THEN @VCC
		ELSE ER.Instance
	  END
  AND 
	EF.Description LIKE CASE
		WHEN @Format IS NOT NULL THEN @Format
		ELSE EF.Description
	  END
  AND 
	EP.Description LIKE CASE
		WHEN @Plan IS NOT NULL THEN @Plan
		ELSE EP.Description
	END
  AND 
	ER.CampaignDescription LIKE CASE
		WHEN @HistoricCampaign IS NOT NULL THEN @HistoricCampaign
		ELSE ER.CampaignDescription
	  END
  AND 
	ER.AgentDescription LIKE CASE
		WHEN @IdAgente IS NOT NULL THEN @IdAgente
		ELSE ER.AgentDescription
	  END
  AND 
	ER.IdAuditor LIKE CASE
		WHEN @IdAuditor IS NOT NULL THEN @IdAuditor
		ELSE ER.IdAuditor
	  END
  AND AEP.[TimeStamp] >=
                          CASE
                            WHEN @StartDate IS NOT NULL THEN @StartDate
                            ELSE '19800101'
                          END
  AND AEP.[TimeStamp] <
                         CASE
                           WHEN @EndDate IS NOT NULL THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END
  --AND EP.[Status] = 7
  AND AEP.[Completed] = 1
	) a

	--select * from #TempEvaluationResult ORDER BY IdInteraction


  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability) 
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')

  --Select @cols
  IF @cols IS NOT NULL
  BEGIN

    DECLARE @type varchar(max)=(Select Top 1 Evaluation_Mode From #TempEvaluationResult)

    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
    --SELECT @type
	If @type = 'M'
	BEGIN
    SET @query = ' 
				Select p.[VCC]							AS [VCC],
						p.DescriptionPlan				As [Plan],
						p.DescriptionFormat				As Formato,
						p.AgentDescription				As Agente,
  						p.CampaignDescription			As [Campana],
						p.IdInteraction					As [Interaccion],
						p.EvaluationDate				As [Fecha Evaluacion],
						p.IdAuditor						As Auditor,
						InteractionDuration				as [Tiempo duracion], 
						null							As [Telefono],
						InteractionDateStart			As [Fecha Inicio],
						null							As [Categoria],
						(' + @Total + ')				As COLUMN_TOTAL_SCORE, 
						p.[AutomaticScore]				AS COLUMN_AUTOMATIC_SCORE,
						p.[ManualScore]					AS COLUMN_MANUAL_SCORE,
						' + @cols + ' 
					from 
				( select VCC,
							DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  AutomaticScore,
						  ManualScore,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock) 
				) as A On
				A.IdInteraction = p.IdInteraction '
    END
	ELSE 
	BEGIN
    SET @query = ' 
				Select p.[VCC]							AS [VCC],
						p.DescriptionPlan				As [Plan],
						p.DescriptionFormat				As Formato,
						p.AgentDescription				As Agente,
  						p.CampaignDescription			As [Campana] ,
						p.IdInteraction					As [Interaccion] ,
						p.EvaluationDate				As [Fecha Evaluacion],
						p.IdAuditor						As Auditor,
						A.DurationTime					as [Tiempo Duracion],
						A.Number						As [Telefono] ,
						A.StartDate						As [Fecha Inicio] ,
						A.Category1						As Categoria ,
						(' + @Total + ')				As COLUMN_TOTAL_SCORE,
						p.[AutomaticScore]				AS COLUMN_AUTOMATIC_SCORE,
						p.[ManualScore]					AS COLUMN_MANUAL_SCORE,
						' + @cols + ' 
					from ( 
						select VCC,
								DescriptionPlan,
								DescriptionFormat,
								Ability,
								AgentDescription,
								CampaignDescription,
								IdInteraction,
								EvaluationDate,
								Qualification,
								AutomaticScore,
								ManualScore,
								IdAuditor			
							from #TempEvaluationResult
					) x pivot 
					( 
						 max(Qualification)
						for Ability in (' + @cols + ')
					) p 
					LEFT Join Audio as A 
						On A.[VCC] = p.[VCC]
							AND A.ID = p.IdInteraction'
	END
	--Print(@query)
    EXECUTE (@query)
    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    SELECT
      '' AS [Plan],
      '' AS Formato,
      '' AS Agente,
      '' AS [Campana],
      '' AS [Interaccion],
      '' AS EvaluationDate,
      '' AS IdAuditor
  END
  
  SET NOCOUNT OFF
GO
PRINT N'Modificando [dbo].[ReportBySummaryAgent]...';


GO


ALTER PROCEDURE [dbo].[ReportBySummaryAgent] (
	@VCC varchar(50) = NULL, 
	@HistoricCampaign varchar(50) = NULL, 
	@Plan varchar(50) = NULL,
	@Format varchar(50) , 
	@StartDate DateTime = NULL , 
	@EndDate DateTime = NULL , 
	@IdAuditor varchar(50) = NULL ,
	@IdAgente varchar(50) = NULL
) AS
  DECLARE @cols varchar(max)
  DECLARE @query varchar(max)
  --ReportBySummaryAgent 'allegro','entrantes',NULL,'nov01-0356',NULL,NULL,NULL,NULL
  --SET @Format = 'nov01-0356'
  SET NOCOUNT ON
  
  SELECT
    * INTO #TempEvaluationResult
  FROM (
  SELECT
    EP.Description AS 'DescriptionPlan',
    EF.Description AS 'DescriptionFormat',
    GP.Description + '-' + SGP.Description + '-' + A.Title AS 'Ability',
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ER.Qualification,
    Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss') AS 'EvaluationDate',
    ER.IdAuditor,
    EP.Evaluation_Mode
  FROM EvaluationResult (NOLOCK) ER
  LEFT JOIN EvaluationFormat (NOLOCK) EF
    ON ER.IdEvaluationFormat = EF.ID
  LEFT JOIN Ability (NOLOCK) A
    ON A.ID = ER.IdAbility
  LEFT JOIN EvaluationPlan (NOLOCK) EP
    ON EP.ID = ER.IdEvaluationPlan
  LEFT JOIN [Group] (NOLOCK) GP
    ON GP.ID = ER.IdGroup
  LEFT JOIN SubGroup SGP (NOLOCK)
    ON SGP.ID = ER.IdSubGroup
  WHERE EF.Description LIKE CASE
    WHEN @Format IS NOT NULL THEN @Format
    ELSE EF.Description
  END
  AND ER.Instance LIKE CASE
    WHEN @VCC IS NOT NULL THEN @VCC
    ELSE ER.Instance
  END
  AND EP.Description LIKE CASE
    WHEN @Plan IS NOT NULL THEN @Plan
    ELSE EP.Description
  END
  AND ER.CampaignDescription LIKE CASE
    WHEN @HistoricCampaign IS NOT NULL THEN @HistoricCampaign
    ELSE ER.CampaignDescription
  END
  AND ER.AgentDescription LIKE CASE
    WHEN @IdAgente IS NOT NULL THEN @IdAgente
    ELSE ER.AgentDescription
  END
  AND ER.IdAuditor LIKE CASE
    WHEN @IdAuditor IS NOT NULL THEN @IdAuditor
    ELSE ER.IdAuditor
  END
  AND ER.EvaluationDate >=
                          CASE
                            WHEN @StartDate IS NOT NULL THEN @StartDate
                            ELSE '19800101'
                          END
  AND ER.EvaluationDate <
                         CASE
                           WHEN @EndDate IS NOT NULL THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END
	) a

	
  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability)
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')
  
  IF @cols IS NOT NULL
  BEGIN
    ------
    DECLARE @type varchar(max) = (SELECT TOP 1
      Evaluation_Mode
    FROM #TempEvaluationResult)
	-------
    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')    
	-- ROUND(AVG(CAST(ER.Qualification AS float)), 2) AS 'Qualification',
    DECLARE @colavg varchar(max) = STUFF((SELECT DISTINCT
      ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As [' + Ability + ' Promedio]'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
	
	--SELECT @colavg
    IF @type = 'M'
    BEGIN
      SET @query = ' 
				Select q.DescriptionPlan As [Plan] ,q.DescriptionFormat As Formato ,q.AgentDescription As Agente ,q.CampaignDescription As Campana ,count(q.IdInteraction) As Auditorias,
				sum(q.DurationTime) As [Tiempo Duracion],ROUND(AVG(CAST(q.Note AS float)), 2) As [Nota Promedio], ' + @colavg + ' From
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,InteractionDuration as DurationTime, 
				null As Number,InteractionDateStart As StartDate,null As Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock)
				) as A On
				A.IdInteraction=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription
				'
    END
    ELSE
    BEGIN
      SET @query = '
	
			    Select q.DescriptionPlan As [Plan] ,q.DescriptionFormat As Formato ,q.AgentDescription As Agente,q.CampaignDescription As Campana,count(q.IdInteraction) As Auditorias,
				sum(q.DurationTime) As [Tiempo Duraccion],ROUND(AVG(CAST(q.Note AS float)), 2) As [Nota Promedio], ' + @colavg + ' From 
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,
				A.DurationTime,A.Number,A.StartDate,A.Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join Audio as A On
				A.ID=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription'
    END
    --Print(@query)
    EXECUTE (@query)
    --Select * From @query
	

    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    DROP TABLE #TempEvaluationResult
    SELECT
      '' AS [Plan],
      '' AS Formato,
      '' AS Agente,
      '' AS Campana
  END
  
  SET NOCOUNT OFF
GO
PRINT N'Creando [dbo].[GetAgentsFromHistoricEvaluationPlans]...';


GO
CREATE PROCEDURE [dbo].[GetAgentsFromHistoricEvaluationPlans] (
	@VCC VARCHAR(50)
	)
AS
BEGIN
	SET NOCOUNT ON
 	
 	SELECT DISTINCT ER.[IdAgent] 'idAgent'
 	FROM [dbo].[EvaluationResult] ER (NOLOCK)
 	JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
 	ON ER.[Instance] = AEP.[Instance] AND ER.IdEvaluationPlan = AEP.IdEvaluationPlan
 	WHERE ER.[Instance] = @VCC AND AEP.Completed = 1

 	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetAuditorsFromEvaluationPlans]...';


GO
CREATE PROCEDURE [dbo].[GetAuditorsFromEvaluationPlans] (
	@VCC VARCHAR(50)
	)
AS
BEGIN
	SET NOCOUNT ON

 	SELECT DISTINCT ER.[IdAuditor] 'idAuditor'
 	FROM [dbo].[EvaluationResult] ER (NOLOCK)
 	JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
 	ON ER.[Instance] = AEP.[Instance] AND ER.IdEvaluationPlan = AEP.IdEvaluationPlan
 	WHERE ER.[Instance] = @VCC AND AEP.Completed = 1

 	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetEvaluationFormatsFromHistoricEvaluationPlans]...';


GO
CREATE PROCEDURE [dbo].[GetEvaluationFormatsFromHistoricEvaluationPlans] (
	@VCC VARCHAR(50)
	)
AS
BEGIN
	SET NOCOUNT ON

 	SELECT DISTINCT 

	[Description] 'description' 

	FROM [dbo].[EvaluationResult] ER (NOLOCK)
    JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
    ON ER.IdEvaluationFormat = EF.ID 
	AND ER.Instance = EF.Instance
	JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
	ON AEP.IdEvaluationPlan = ER.IdEvaluationPlan
	AND AEP.Instance = ER.Instance
	WHERE EF.Instance =  @VCC AND AEP.Completed = 1

 	SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';


GO
