
GO
PRINT N'Creando [dbo].[HistoricAbility]...';


GO
CREATE TABLE [dbo].[HistoricAbility] (
    [VCC]            VARCHAR (50)   NOT NULL,
    [ID]             VARCHAR (50)   NOT NULL,
    [Title]          VARCHAR (100)  NULL,
    [Detail]         VARCHAR (500)  NULL,
    [Type]           VARCHAR (50)   NULL,
    [Binary]         BIT            NULL,
    [NotApply]       BIT            NULL,
    [Distribute]     BIT            NULL,
    [AcceptComments] BIT            NULL,
    [Enabled]        BIT            NULL,
    [AnalysisType]   VARCHAR (25)   NULL,
    [Query]          VARCHAR (1000) NULL,
    [QueryName]      VARCHAR (50)   NULL,
    [Language]       VARCHAR (50)   NULL,
    [IsNegative]     BIT            NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricAbility].[Index_HistoricAbility]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricAbility]
    ON [dbo].[HistoricAbility]([Title] ASC, [Detail] ASC, [Type] ASC, [Query] ASC);


GO
PRINT N'Creando [dbo].[HistoricAbilityEvaluationFormat]...';


GO
CREATE TABLE [dbo].[HistoricAbilityEvaluationFormat] (
    [VCC]                VARCHAR (50)   NOT NULL,
    [ID]                 INT            NOT NULL,
    [IdEvaluationFormat] VARCHAR (50)   NULL,
    [IdAbility]          VARCHAR (50)   NULL,
    [IdGroup]            VARCHAR (50)   NULL,
    [IdSubGroup]         VARCHAR (50)   NULL,
    [Penalizes]          VARCHAR (3)    NULL,
    [Score]              NUMERIC (5, 2) NULL,
    [Order]              NUMERIC (3)    NULL,
    [Conditional]        VARCHAR (50)   NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricAbilityEvaluationFormat].[Index_HistoricAbilityEvaluationFormat]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricAbilityEvaluationFormat]
    ON [dbo].[HistoricAbilityEvaluationFormat]([IdEvaluationFormat] ASC, [IdAbility] ASC, [IdGroup] ASC, [IdSubGroup] ASC, [Score] ASC, [Order] ASC);


GO
PRINT N'Creando [dbo].[HistoricAbilityQuery]...';


GO
CREATE TABLE [dbo].[HistoricAbilityQuery] (
    [ID]                   VARCHAR (50)    NOT NULL,
    [VCC]                  VARCHAR (50)    NOT NULL,
    [AbilityId]            VARCHAR (50)    NULL,
    [QueryId]              VARCHAR (50)    NULL,
    [QueryContent]         VARCHAR (MAX)   NULL,
    [AcceptancePercentage] DECIMAL (18, 2) NULL,
    [Order]                INT             NULL,
    PRIMARY KEY CLUSTERED ([ID] ASC, [VCC] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricAbilityQueryEntity]...';


GO
CREATE TABLE [dbo].[HistoricAbilityQueryEntity] (
    [VCC]                  VARCHAR (50)    NULL,
    [AbilityQueryId]       VARCHAR (50)    NULL,
    [EntityId]             VARCHAR (50)    NULL,
    [EntityName]           VARCHAR (50)    NULL,
    [AcceptancePercentage] DECIMAL (18, 2) NULL,
    [Order]                INT             NULL
);


GO
PRINT N'Creando [dbo].[HistoricCampaignEvaluationFormat]...';


GO
CREATE TABLE [dbo].[HistoricCampaignEvaluationFormat] (
    [VCC]                VARCHAR (50) NOT NULL,
    [IdEvaluationFormat] VARCHAR (50) NOT NULL,
    [IdCampaign]         VARCHAR (50) NOT NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [IdEvaluationFormat] ASC, [IdCampaign] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricCustomField]...';


GO
CREATE TABLE [dbo].[HistoricCustomField] (
    [VCC]         VARCHAR (50)  NULL,
    [ID]          VARCHAR (100) NULL,
    [Description] VARCHAR (250) NULL,
    [Type]        VARCHAR (50)  NULL,
    [Label]       VARCHAR (50)  NULL
);


GO
PRINT N'Creando [dbo].[HistoricCustomField].[Index_HistoricCustomField]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricCustomField]
    ON [dbo].[HistoricCustomField]([VCC] ASC, [ID] ASC, [Description] ASC);


GO
PRINT N'Creando [dbo].[HistoricCustomFieldResult]...';


GO
CREATE TABLE [dbo].[HistoricCustomFieldResult] (
    [VCC]           VARCHAR (50)  NULL,
    [ID]            VARCHAR (50)  NULL,
    [Description]   VARCHAR (100) NULL,
    [Order]         INT           NULL,
    [CustomFieldId] VARCHAR (100) NULL
);


GO
PRINT N'Creando [dbo].[HistoricCustomFieldResult].[Index_HistoricCustomFieldResult]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricCustomFieldResult]
    ON [dbo].[HistoricCustomFieldResult]([VCC] ASC, [ID] ASC, [Description] ASC, [CustomFieldId] ASC);


GO
PRINT N'Creando [dbo].[HistoricEvaluationFormat]...';


GO
CREATE TABLE [dbo].[HistoricEvaluationFormat] (
    [VCC]                        VARCHAR (50)   NOT NULL,
    [ID]                         VARCHAR (50)   NOT NULL,
    [Description]                VARCHAR (100)  NULL,
    [Type]                       VARCHAR (100)  NULL,
    [EnvironmentType]            VARCHAR (100)  NULL,
    [MinAutomaticQualification]  NUMERIC (5, 2) NULL,
    [MinQualificationAcceptable] NUMERIC (5, 2) NULL,
    [ManagementFormURL]          VARCHAR (1000) NULL,
    [Enabled]                    BIT            NULL,
    [TemplateId]                 VARCHAR (50)   NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricEvaluationFormat].[Index_HistoricEvaluationFormat]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricEvaluationFormat]
    ON [dbo].[HistoricEvaluationFormat]([Description] ASC, [Type] ASC);


GO
PRINT N'Creando [dbo].[HistoricEvaluationFormatAttachedSignature]...';


GO
CREATE TABLE [dbo].[HistoricEvaluationFormatAttachedSignature] (
    [VCC]                VARCHAR (50) NULL,
    [Description]        VARCHAR (50) NULL,
    [Order]              INT          NULL,
    [EvaluationFormatId] VARCHAR (50) NULL
);


GO
PRINT N'Creando [dbo].[HistoricEvaluationFormatAttachedSignature].[Index_HistoricEvaluationFormatAttachedSignature]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricEvaluationFormatAttachedSignature]
    ON [dbo].[HistoricEvaluationFormatAttachedSignature]([VCC] ASC, [EvaluationFormatId] ASC, [Description] ASC);


GO
PRINT N'Creando [dbo].[HistoricEvaluationFormatCustomField]...';


GO
CREATE TABLE [dbo].[HistoricEvaluationFormatCustomField] (
    [VCC]                VARCHAR (50)  NOT NULL,
    [ID]                 VARCHAR (50)  NULL,
    [EvaluationFormatId] VARCHAR (50)  NOT NULL,
    [CustomFieldId]      VARCHAR (100) NOT NULL,
    [Order]              INT           NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [EvaluationFormatId] ASC, [CustomFieldId] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricGenericTemplateQuery]...';


GO
CREATE TABLE [dbo].[HistoricGenericTemplateQuery] (
    [VCC]        VARCHAR (50)  NOT NULL,
    [TemplateId] VARCHAR (50)  NOT NULL,
    [ID]         VARCHAR (50)  NOT NULL,
    [Query]      VARCHAR (MAX) NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [TemplateId] ASC, [ID] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricGroup]...';


GO
CREATE TABLE [dbo].[HistoricGroup] (
    [VCC]         VARCHAR (50)  NOT NULL,
    [ID]          VARCHAR (50)  NOT NULL,
    [Description] VARCHAR (100) NULL,
    [Enabled]     BIT           NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricGroup].[Index_HistoricGroup]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricGroup]
    ON [dbo].[HistoricGroup]([Description] ASC);


GO
PRINT N'Creando [dbo].[HistoricSubGroup]...';


GO
CREATE TABLE [dbo].[HistoricSubGroup] (
    [VCC]         VARCHAR (50)  NOT NULL,
    [ID]          VARCHAR (50)  NOT NULL,
    [Description] VARCHAR (100) NULL,
    [Enabled]     BIT           NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricSubGroup].[Index_HistoricSubGroup]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricSubGroup]
    ON [dbo].[HistoricSubGroup]([Description] ASC);


GO
PRINT N'Creando [dbo].[HistoricTemplate]...';


GO
CREATE TABLE [dbo].[HistoricTemplate] (
    [VCC]         VARCHAR (50) NOT NULL,
    [Name]        VARCHAR (50) NOT NULL,
    [Type]        VARCHAR (50) NULL,
    [Description] VARCHAR (50) NULL,
    [Template]    VARCHAR (50) NULL,
    [Category]    VARCHAR (50) NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [Name] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricTemplate].[Index_HistoricTemplate]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricTemplate]
    ON [dbo].[HistoricTemplate]([Type] ASC, [Description] ASC);


GO
PRINT N'Creando [dbo].[HistoricTemplateTheme]...';


GO
CREATE TABLE [dbo].[HistoricTemplateTheme] (
    [VCC]          VARCHAR (50)  NOT NULL,
    [TemplateId]   VARCHAR (50)  NOT NULL,
    [ID]           VARCHAR (200) NOT NULL,
    [Order]        INT           NULL,
    [Description]  VARCHAR (50)  NULL,
    [Category1]    VARCHAR (50)  NULL,
    [Category2]    VARCHAR (50)  NULL,
    [AnalysisType] VARCHAR (15)  NULL,
    [IsNegative]   BIT           NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [TemplateId] ASC, [ID] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricTemplateThemeItem]...';


GO
CREATE TABLE [dbo].[HistoricTemplateThemeItem] (
    [VCC]                  VARCHAR (50)   NOT NULL,
    [TemplateId]           VARCHAR (50)   NOT NULL,
    [TemplateThemeId]      VARCHAR (200)  NOT NULL,
    [ID]                   VARCHAR (50)   NOT NULL,
    [AcceptancePercentage] DECIMAL (5, 2) NULL,
    PRIMARY KEY CLUSTERED ([VCC] ASC, [TemplateId] ASC, [TemplateThemeId] ASC, [ID] ASC)
);


GO
PRINT N'Creando [dbo].[HistoricTemplateThemeItemEntity]...';


GO
CREATE TABLE [dbo].[HistoricTemplateThemeItemEntity] (
    [VCC]                  VARCHAR (50)    NULL,
    [TemplateId]           VARCHAR (50)    NULL,
    [TemplateThemeId]      VARCHAR (50)    NULL,
    [TemplateThemeItemId]  VARCHAR (50)    NULL,
    [EntityId]             VARCHAR (50)    NULL,
    [EntityName]           VARCHAR (50)    NULL,
    [AcceptancePercentage] DECIMAL (18, 2) NULL,
    [Order]                INT             NULL
);


GO
PRINT N'Creando [dbo].[HistoricTemplateThemeItemEntity].[Index_HistoricTemplateThemeItemEntity]...';


GO
CREATE NONCLUSTERED INDEX [Index_HistoricTemplateThemeItemEntity]
    ON [dbo].[HistoricTemplateThemeItemEntity]([TemplateThemeId] ASC, [TemplateThemeItemId] ASC, [EntityId] ASC, [EntityName] ASC);


GO
PRINT N'Creando restricción sin nombre en [dbo].[HistoricAbilityQuery]...';


GO
ALTER TABLE [dbo].[HistoricAbilityQuery]
    ADD DEFAULT ((0)) FOR [AcceptancePercentage];


GO
PRINT N'Creando restricción sin nombre en [dbo].[HistoricAbilityQueryEntity]...';


GO
ALTER TABLE [dbo].[HistoricAbilityQueryEntity]
    ADD DEFAULT ((0)) FOR [AcceptancePercentage];


GO
PRINT N'Creando restricción sin nombre en [dbo].[HistoricTemplateTheme]...';


GO
ALTER TABLE [dbo].[HistoricTemplateTheme]
    ADD DEFAULT ((0)) FOR [IsNegative];


GO
PRINT N'Creando restricción sin nombre en [dbo].[HistoricTemplateThemeItem]...';


GO
ALTER TABLE [dbo].[HistoricTemplateThemeItem]
    ADD DEFAULT ((0)) FOR [AcceptancePercentage];


GO
PRINT N'Modificando [dbo].[GetAbilityEvaluationFormats]...';


GO


ALTER PROCEDURE [dbo].[GetAbilityEvaluationFormats] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationFormat Varchar(50) = NULL,
	@Historic BIT = 0
) AS
BEGIN
	SET NOCOUNT ON

	 IF(@Historic = 1)
	 BEGIN 
			 SELECT AEF.[ID]							'id',
					AEF.[IdEvaluationFormat]		'idEvaluationFormat',
					AEF.[IdAbility]					'idAbility',
					A.[Title]						'titleAbility',
					A.[Detail]						'detailAbility',
					A.[Type]						'abilityType',
					A.[AnalysisType]				'abilityAnalysisType',
					AEF.[IdGroup]					'idGroup',
					G.[Description]                 'descriptionGroup',
					AEF.[IdSubGroup]				'idSubGroup',
					SG.[Description]                'descriptionSubGroup',
					AEF.[Penalizes]					'penalizes',
					AEF.[Score]						'score',
					AEF.[Order]						'order',
					A.[NotApply]					'acceptNotApplies',
					A.[Distribute]					'distribute',
					A.[AcceptComments]				'acceptComments',
					A.[Detail]						'descriptionAbility',
					AEF.[Conditional]				'conditional',
					A.[Query]						'abilityQuery',
					A.QueryName						'query',
					A.[IsNegative]                  'isNegative'
				FROM [dbo].[HistoricAbilityEvaluationFormat] AEF (NOLOCK)
				INNER JOIN [dbo].[HistoricGroup] G (NOLOCK)
					ON G.[VCC] = AEF.[VCC]
						AND G.[ID] = AEF.[IdGroup]
				INNER JOIN [dbo].[HistoricSubGroup] SG (NOLOCK)
					ON SG.[VCC] = AEF.[VCC]
						AND SG.[ID] = AEF.[IdSubGroup]
				INNER JOIN [dbo].[HistoricAbility] A (NOLOCK)
					ON A.[VCC] = AEF.[VCC]
						AND A.[ID] = AEF.[IdAbility]
				WHERE AEF.[VCC] = @Instance
					AND AEF.[IdEvaluationFormat]= @IdEvaluationFormat
				ORDER BY [Order] ASC
	
	 END
	 ELSE
	 BEGIN 
			 SELECT AEF.[ID]							'id',
					AEF.[IdEvaluationFormat]		'idEvaluationFormat',
					AEF.[IdAbility]					'idAbility',
					A.[Title]						'titleAbility',
					A.[Detail]						'detailAbility',
					A.[Type]						'abilityType',
					A.[AnalysisType]				'abilityAnalysisType',
					AEF.[IdGroup]					'idGroup',
					G.[Description]                 'descriptionGroup',
					AEF.[IdSubGroup]				'idSubGroup',
					SG.[Description]                'descriptionSubGroup',
					AEF.[Penalizes]					'penalizes',
					AEF.[Score]						'score',
					AEF.[Order]						'order',
					A.[NotApply]					'acceptNotApplies',
					A.[Distribute]					'distribute',
					A.[AcceptComments]				'acceptComments',
					A.[Detail]						'descriptionAbility',
					AEF.[Conditional]				'conditional',
					A.[Query]						'abilityQuery',
					A.QueryName						'query',
					A.[IsNegative]                  'isNegative'
				FROM [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
				INNER JOIN [dbo].[Group] G (NOLOCK)
					ON G.[Instance] = AEF.[Instance]
						AND G.[ID] = AEF.[IdGroup]
				INNER JOIN [dbo].[SubGroup] SG (NOLOCK)
					ON SG.[Instance] = AEF.[Instance]
						AND SG.[ID] = AEF.[IdSubGroup]
				INNER JOIN [dbo].[Ability] A (NOLOCK)
					ON A.[Instance] = AEF.[Instance]
						AND A.[ID] = AEF.[IdAbility]
				WHERE AEF.[Instance] = @Instance
					AND AEF.[IdEvaluationFormat]= @IdEvaluationFormat
				ORDER BY [Order] ASC
			
	 END
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAbilityQueries]...';


GO
ALTER PROCEDURE [dbo].[GetAbilityQueries] (
	@VCC VARCHAR(50) = NULL, 
	@AbilityId VARCHAR(100) = NULL,
	@Historic BIT = 0
) AS
BEGIN
	SET NOCOUNT ON

    IF(@Historic = 1)
    BEGIN
		    	SELECT [AQ].[ID]												'id',
					[AQ].[QueryId]											'queryId',
					[AQ].[QueryContent]										'queryContent',
					[AQ].[AcceptancePercentage]								'acceptancePercentage',
					ISNULL([AQ].[AcceptancePercentage], 0) * 100			'acceptanceInteger',
					[AQ].[Order]											'order'
				FROM [dbo].[HistoricAbilityQuery] AQ (NOLOCK)
				WHERE [AQ].[VCC] = @VCC
					AND [AQ].[AbilityId] = @AbilityId
				ORDER BY [AQ].[Order] ASC
    END
    ELSE
    BEGIN	
			SELECT [AQ].[ID]												'id',
					[AQ].[QueryId]											'queryId',
					[AQ].[QueryContent]										'queryContent',
					[AQ].[AcceptancePercentage]								'acceptancePercentage',
					ISNULL([AQ].[AcceptancePercentage], 0) * 100			'acceptanceInteger',
					[AQ].[Order]											'order'
				FROM [dbo].[AbilityQuery] AQ (NOLOCK)
				WHERE [AQ].[VCC] = @VCC
					AND [AQ].[AbilityId] = @AbilityId
				ORDER BY [AQ].[Order] ASC
     END
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAbilityQueryEntities]...';


GO
ALTER PROCEDURE [dbo].[GetAbilityQueryEntities] (
	@VCC VARCHAR(50) = NULL, 
	@AbilityQueryId VARCHAR(100) = NULL,
	@Historic BIT = 0
) AS
BEGIN
	SET NOCOUNT ON

IF(@Historic = 1)
BEGIN
	    SELECT [AQE].[EntityId]										'entityId',
			   [AQE].[EntityName]									'entityName',
			   [AQE].[AcceptancePercentage]						    'acceptancePercentage',
			   ISNULL([AQE].[AcceptancePercentage], 0) * 100		'acceptanceInteger',
			   [AQE].[Order]										'order'
		FROM [dbo].[HistoricAbilityQueryEntity] AQE (NOLOCK)
		WHERE [AQE].[VCC] = @VCC
			AND [AQE].[AbilityQueryId] = @AbilityQueryId
		ORDER BY [AQE].[Order] ASC
END 
ELSE 
BEGIN 
	    SELECT [AQE].[EntityId]										'entityId',
			   [AQE].[EntityName]									'entityName',
			   [AQE].[AcceptancePercentage]						    'acceptancePercentage',
			   ISNULL([AQE].[AcceptancePercentage], 0) * 100		'acceptanceInteger',
			   [AQE].[Order]										'order'
		FROM [dbo].[AbilityQueryEntity] AQE (NOLOCK)
		WHERE [AQE].[VCC] = @VCC
			AND [AQE].[AbilityQueryId] = @AbilityQueryId
		ORDER BY [AQE].[Order] ASC
END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetCampaignEvaluationFormats]...';


GO
ALTER PROCEDURE [dbo].[GetCampaignEvaluationFormats] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationFormat Varchar(50) = NULL,
	@Historic BIT = 0
	)
AS
BEGIN
	SET NOCOUNT ON
	
	IF(@Historic = 1)
	BEGIN
			SELECT
				CE.[IdEvaluationFormat]			'idEvaluationFormat',
				CE.[IdCampaign]					'idCampain',
				CE.[IdCampaign]                 'descriptionCampain'
			FROM [HistoricCampaignEvaluationFormat] CE (NOLOCK)
			WHERE CE.[VCC] = @Instance
			AND CE.[IdEvaluationFormat]= @IdEvaluationFormat
	END
	ELSE
	BEGIN
			SELECT
				CE.[IdEvaluationFormat]			'idEvaluationFormat',
				CE.[IdCampaign]					'idCampain',
				CE.[IdCampaign]                 'descriptionCampain'
			FROM [CampaignEvaluationFormat] CE (NOLOCK)
			WHERE CE.[Instance] = @Instance
			AND CE.[IdEvaluationFormat]= @IdEvaluationFormat
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetCustomField]...';


GO
ALTER PROCEDURE [dbo].[GetCustomField] (
	@VCC VARCHAR(50) = NULL, 
	@ID VARCHAR(100) = NULL,
	@Historic BIT = 0
) AS
BEGIN
	SET NOCOUNT ON

    IF(@Historic = 1)
    BEGIN 
	    SELECT  [ID]						'id',
				[Description]				'description',
				[Label]						'label',
				[Type]						'type'
		FROM [HistoricCustomField] (NOLOCK)
		WHERE [VCC] = @VCC
			AND [ID] = @ID
    END
    ELSE
    BEGIN 
	    SELECT [ID]							'id',
				[Description]				'description',
				[Label]						'label',
				[Type]						'type'
		FROM [CustomField] (NOLOCK)
		WHERE [VCC] = @VCC
			AND [ID] = @ID
    END
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetCustomFieldResults]...';


GO
ALTER PROCEDURE [dbo].[GetCustomFieldResults] (
	@VCC VARCHAR(50) = NULL,
	@CustomFieldId VARCHAR(100) = NULL,
	@Historic BIT = 0
) AS
BEGIN
	SET NOCOUNT ON

    IF(@Historic = 1)
    BEGIN 
	    	SELECT CFR.[ID]							'id',
				CFR.[Description]				'description',
				CFR.[Order]						'order'
			FROM [HistoricCustomFieldResult] CFR (NOLOCK)
			WHERE CFR.[VCC] = @VCC
				AND CFR.[CustomFieldId] = @CustomFieldId
			ORDER BY CFR.[Order] ASC
    END
    ELSE
    BEGIN 
	    	SELECT CFR.[ID]							'id',
				CFR.[Description]				'description',
				CFR.[Order]						'order'
			FROM [CustomFieldResult] CFR (NOLOCK)
			WHERE CFR.[VCC] = @VCC
				AND CFR.[CustomFieldId] = @CustomFieldId
			ORDER BY CFR.[Order] ASC
    END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(100) = NULL,
	@InteractionId VARCHAR(250) = NULL,
	@AuditorId VARCHAR(50) = NULL,
	@AgentId VARCHAR(50) = NULL,
	@Historic BIT = 0
) AS
BEGIN
	SET NOCOUNT ON

IF(@Historic = 1)
BEGIN 
			 SELECT ECFR.[VCC]								'vcc',
					ECFR.[EvaluationPlanId]					'evaluationPlanId',
					ECFR.[InteractionId]					'interactionId',
					ECFR.[AuditorId]						'auditorId',
					ECFR.[AgentId]							'agentId',
					ECFR.[CustomFieldId]					'customFieldId',
					CASE WHEN CFR.[ID] IS NULL 
						THEN ECFR.[Result] 
						ELSE CFR.[Description] END			'result'
				FROM [dbo].[EvaluationCustomFieldResult] ECFR (NOLOCK)
				LEFT JOIN [dbo].[HistoricCustomFieldResult] CFR (NOLOCK)
					ON CFR.[VCC] = ECFR.[VCC]
						AND CFR.[CustomFieldId] = ECFR.[CustomFieldId]
						AND CFR.[ID] =ECFR.[Result]
				WHERE ECFR.[VCC] = @VCC
					AND ECFR.[EvaluationPlanId] = @EvaluationPlanId
					AND ECFR.[InteractionId] = @InteractionId
					AND ECFR.[AuditorId] = @AuditorId
					AND ECFR.[AgentId] = @AgentId
END
ELSE
BEGIN 
			 SELECT ECFR.[VCC]								'vcc',
					ECFR.[EvaluationPlanId]					'evaluationPlanId',
					ECFR.[InteractionId]					'interactionId',
					ECFR.[AuditorId]						'auditorId',
					ECFR.[AgentId]							'agentId',
					ECFR.[CustomFieldId]					'customFieldId',
					CASE WHEN CFR.[ID] IS NULL 
						THEN ECFR.[Result] 
						ELSE CFR.[Description] END			'result'
				FROM [dbo].[EvaluationCustomFieldResult] ECFR (NOLOCK)
				LEFT JOIN [dbo].[CustomFieldResult] CFR (NOLOCK)
					ON CFR.[VCC] = ECFR.[VCC]
						AND CFR.[CustomFieldId] = ECFR.[CustomFieldId]
						AND CFR.[ID] =ECFR.[Result]
				WHERE ECFR.[VCC] = @VCC
					AND ECFR.[EvaluationPlanId] = @EvaluationPlanId
					AND ECFR.[InteractionId] = @InteractionId
					AND ECFR.[AuditorId] = @AuditorId
					AND ECFR.[AgentId] = @AgentId

END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationFormat]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationFormat] (
	@Instance Varchar(50) = NULL,
	@ID Varchar(50) = NULL,
	@Historic BIT = 0
	)
AS
BEGIN
	SET NOCOUNT ON
    IF(@Historic = 1)
    BEGIN 
		SELECT
			[ID]									'id',
			[Description]							'description',
			[EnvironmentType]						'environmentType',
			[Type]									'type',
			[MinQualificationAcceptable]			'minQualificationAcceptable',
			[MinAutomaticQualification]				'minAutomaticQualification',
			[ManagementFormURL]						'managementFormURL',
			[Enabled]								'enabled',
			[templateId]							'templateId'
		FROM [HistoricEvaluationFormat] (NOLOCK)
		WHERE [VCC] = @Instance
			AND [ID] = @ID
   END
   ELSE
   BEGIN 
   		SELECT
			[ID]									'id',
			[Description]							'description',
			[EnvironmentType]						'environmentType',
			[Type]									'type',
			[MinQualificationAcceptable]			'minQualificationAcceptable',
			[MinAutomaticQualification]				'minAutomaticQualification',
			[CreatedDate]							'createdDate',
			[CreatedByUserId]						'createdByUserId',
			[LastModifiedDate]						'lastModifiedDate',
			[LastModifiedByUserId]					'lastModifiedByUserId',
			[ManagementFormURL]						'managementFormURL',
			[Enabled]								'enabled',
			[templateId]							'templateId'
		FROM [EvaluationFormat] (NOLOCK)
		WHERE [Instance] = @Instance
			AND [ID] = @ID
   END
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationFormatAttachedSignatures]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationFormatAttachedSignatures] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL,
	@Historic BIT = 0
) AS
BEGIN
	SET NOCOUNT ON
	
    DECLARE @FIND_SYSTEM BIT = 1
    
    IF(@Historic = 1)
    BEGIN 
		    	-- LOS FORMATOS CREADOS PREVIAMENTE A LA IMPLEMENTACION DE FIRMAS ADJUNTAS NO RETORNAN RESULTADO
			IF EXISTS(
				SELECT 1
					FROM [dbo].[HistoricEvaluationFormatAttachedSignature] EFAS (NOLOCK)
					WHERE (
						(EFAS.[VCC] = @VCC AND EFAS.[EvaluationFormatId] = @EvaluationFormatId)
						OR
						(EFAS.[VCC] = 'system' AND EFAS.[EvaluationFormatId] IS NULL AND @EvaluationFormatId IS NULL)
					)
			)
			BEGIN
		        SET @FIND_SYSTEM = 0
		        
				SELECT --EFAS.[VCC]							'vcc',
						EFAS.[Description]					'description',
						EFAS.[EvaluationFormatId]			'evaluationFormatId',
						EFAS.[Order]						'order'
					FROM [dbo].[HistoricEvaluationFormatAttachedSignature] EFAS (NOLOCK)
					WHERE (
						(EFAS.[VCC] = @VCC AND EFAS.[EvaluationFormatId] = @EvaluationFormatId)
						OR
						(EFAS.[VCC] = 'system' AND EFAS.[EvaluationFormatId] IS NULL AND @EvaluationFormatId IS NULL)
					)
					ORDER BY EFAS.[Order] ASC
			END

    END 
    ELSE 
    BEGIN 
		    	-- LOS FORMATOS CREADOS PREVIAMENTE A LA IMPLEMENTACION DE FIRMAS ADJUNTAS NO RETORNAN RESULTADO
			IF EXISTS(
				SELECT 1
					FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
					WHERE (
						(EFAS.[VCC] = @VCC AND EFAS.[EvaluationFormatId] = @EvaluationFormatId)
						OR
						(EFAS.[VCC] = 'system' AND EFAS.[EvaluationFormatId] IS NULL AND @EvaluationFormatId IS NULL)
					)
			)
			BEGIN
		        SET @FIND_SYSTEM = 0
				SELECT --EFAS.[VCC]							'vcc',
						EFAS.[Description]					'description',
						EFAS.[EvaluationFormatId]			'evaluationFormatId',
						EFAS.[Order]						'order'
					FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
					WHERE (
						(EFAS.[VCC] = @VCC AND EFAS.[EvaluationFormatId] = @EvaluationFormatId)
						OR
						(EFAS.[VCC] = 'system' AND EFAS.[EvaluationFormatId] IS NULL AND @EvaluationFormatId IS NULL)
					)
					ORDER BY EFAS.[Order] ASC
			END

    END
    
    
    IF(@FIND_SYSTEM = 1)
    BEGIN 
    				-- LLAMAMOS POR DEFECTO LOS REGISTROS DE SYSTEM
				SELECT EFAS.[Description]					'description',
						EFAS.[EvaluationFormatId]			'evaluationFormatId',
						EFAS.[Order]						'order'
				FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
				WHERE EFAS.[VCC] = 'system' 
					AND EFAS.[EvaluationFormatId] IS NULL
				ORDER BY EFAS.[Order] ASC
    END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationFormatCustomFields]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationFormatCustomFields] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL,
	@Historic  BIT = 0
) AS 
BEGIN
	SET NOCOUNT ON

	IF(@Historic = 1)
	BEGIN
				SELECT EFCF.[VCC]						    'vcc',
					EFCF.[ID]								'id',
					EFCF.[CustomFieldId]					'customFieldId',
					EFCF.[Order]							'order'
				FROM [dbo].[HistoricEvaluationFormatCustomField] EFCF (NOLOCK)
				WHERE EFCF.[VCC] = @VCC 
					AND EFCF.[EvaluationFormatId] = @EvaluationFormatId
				ORDER BY EFCF.[Order] ASC
	END 
	ELSE
	BEGIN 
			   SELECT EFCF.[VCC]							'vcc',
					EFCF.[ID]								'id',
					EFCF.[CustomFieldId]					'customFieldId',
					EFCF.[Order]							'order'
				FROM [dbo].[EvaluationFormatCustomField] EFCF (NOLOCK)
				WHERE EFCF.[VCC] = @VCC 
					AND EFCF.[EvaluationFormatId] = @EvaluationFormatId
				ORDER BY EFCF.[Order] ASC
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationFormatsFromHistoricEvaluationPlans]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationFormatsFromHistoricEvaluationPlans] (
	@VCC VARCHAR(50)
	)
AS
BEGIN
	SET NOCOUNT ON

 	SELECT DISTINCT 
    [ID]          'id',
	[Description] 'description' 

	FROM [dbo].[EvaluationResult] ER (NOLOCK)
    JOIN [dbo].[HistoricEvaluationFormat] EF (NOLOCK)
    ON ER.IdEvaluationFormat = EF.ID 
	AND ER.Instance = EF.VCC
	JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
	ON AEP.IdEvaluationPlan = ER.IdEvaluationPlan
	AND AEP.Instance = ER.Instance
	WHERE EF.VCC =  @VCC AND AEP.Completed = 1

 	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan] (
	@Instance Varchar(50) = NULL,
    @EvaluationPlanId Varchar(50) = NULL,
    @InteractionId varchar(250) = NULL,
    @InteractionType varchar(50) = NULL,
    @AuditorId varchar(50) = NULL,
    @AgentId varchar(50) = NULL
)
AS
BEGIN
    SET NOCOUNT ON

	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART
	;WITH CTE AS (
		SELECT TOP 1 IEP.[Instance],
						IEP.[IdEvaluationPlan],
						IEP.[IdInteraction],
						IEP.[IdAgent],
						IEP.[AgentName]
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @Instance
				AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
				AND IEP.[IdInteraction] = @InteractionId 
				AND IEP.[InteractionType] = @InteractionType
				AND IEP.[IdAgent] = @AgentId
	)

    SELECT DISTINCT
         EF.Id										'EvaluationFormatId'				-- Id
        ,EF.Description								'EvaluationFormatDescription'		-- Titulo del reporte
        ,ER.Instance								'Instance'							-- Subtitulo del reporte
        ,ER.IdAgent									'AgentId'							-- Agente
        ,ER.IdAgent									'AgentDescription'					-- Agente
		,C.[AgentName]								'agentName'							-- NOMBRE DEL AGENTE
        ,CONCAT(U.Firstname, ' ', U.Lastname)		'CoordinatorFullName'				-- Coordinador
        ,AEP.IdAuditor								'AuditorId'							-- Auditor
        ,CONCAT(UA.Firstname, ' ',UA.Lastname)		'AuditorDescription'				-- Auditor
		,AEP.IdAuditor
        ,ER.IdCampaign								'CampaignDescription'				-- Campana
        ,ER.IdInteraction							'InteractionId'						-- Grabacion
        ,ER.InteractionType							'InteractionType'					-- Tipo interaccion
        ,ER.InteractionDateini						'InteractionDateIni'				-- Fecha inicio de la interaccion
		,ER.[InteractionDatefin]					'InteractionDateFin'				-- Fecha fin de la interaccion
        ,ER.InteractionAddress						'Contacto'							-- Telefono
        ,ER.EvaluationDate							'EvaluationDate'					-- Fecha monitoreo
        ,AEP.Score									'TotalScore'						-- Puntaje total
        ,G.Id										'GroupId'							-- Grupo
        ,G.Description								'Group'								-- Grupo
        ,SG.Id										'SubGroupId'						-- Subgrupo
        ,SG.Description								'SubGroup'							-- Subgrupo
        ,AB.Id										'AbilityId'							-- Habilidad
        ,AB.Title									'Ability'							-- Habilidad
		,AB.[Detail]								'AbilityDetail'						-- Habilidad
        ,ER.Comment									'Observacion'						-- Observacion de la habilidad
        ,ER.MaxAbilityScore							'Puntaje'							-- Puntaje
        ,ER.ScoreDescription						'Eval'								-- Eval
        ,ER.Qualification							'Nota'								-- Nota
		,ER.[OwnScore]								'ownScore'
		,ER.[InheritedScore]						'inheritedScore'
		,ER.[AbilityInnerScore]						'abilityInnerScore'
        ,ER.NotApplies								'NotApplies'
		,AB.[Distribute]							'distribute'
        ,ER.AbilityOrder							'Order'
        ,ER.Conditional                             'conditionalSelected'
    FROM [dbo].[EvaluationResult] ER (NOLOCK)
    JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
         ON (EP.[Instance]=ER.[Instance]
         AND EP.ID=ER.IdEvaluationPlan)
    INNER JOIN	[dbo].[HistoricEvaluationFormat] EF (NOLOCK)
	--LEFT JOIN [EvaluationFormat] EF (NOLOCK)
		ON (ER.Instance = EF.VCC 
			AND	ER.IdEvaluationFormat = EF.ID)
    LEFT JOIN [dbo].[User] U (NOLOCK)
		ON (EP.Instance = U.VCC
			AND EP.CreatedByUserId = U.ID)
    --INNER JOIN [User] UA (NOLOCK)
	LEFT JOIN [dbo].[User] UA (NOLOCK)
		ON (ER.Instance = UA.VCC 
			AND ER.IdEvaluator = UA.ID)
    --INNER JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
	LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		ON (ER.IdEvaluationPlan	= AEP.IdEvaluationPlan
			AND ER.IdEvaluator = AEP.IdAuditor
			AND ER.IdInteraction = AEP.IdInteraction
			AND ER.InteractionType = AEP.InteractionType
			AND ER.IdAgent = AEP.IdAgent)
    LEFT JOIN [dbo].[HistoricGroup] G (NOLOCK)
		ON (ER.Instance = G.VCC
			AND ER.IdGroup = G.ID)
    LEFT JOIN [HistoricSubGroup] SG (NOLOCK)
		ON (ER.Instance = SG.VCC 
			AND ER.IdSubGroup = SG.ID)
    LEFT JOIN [HistoricAbility] AB (NOLOCK)
		ON (ER.Instance = AB.VCC 
			AND ER.IdAbility = AB.ID)
	LEFT JOIN CTE C (NOLOCK) -- LA TABLA AGENT NO ES DETERMINANTE POR ESO SE AGREGA POR LEFT JOIN
		ON C.[Instance] = ER.[Instance]
			AND C.[IdInteraction] = ER.IdInteraction
			AND C.[IdAgent] = ER.[IdAgent]
    WHERE ER.Instance = @Instance
		AND ER.IdEvaluationPlan	= @EvaluationPlanId
		AND ER.IdInteraction = @InteractionId
		AND ER.InteractionType = @InteractionType
		--AND ER.IdEvaluator = @AuditorId
		AND ER.[IdAuditor] = @AuditorId
		AND ER.IdAgent = @AgentId
    ORDER BY ER.AbilityOrder ASC;

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetStudyResultSummary]...';


GO
ALTER PROCEDURE [dbo].[GetStudyResultSummary]
(
	@VCC					VARCHAR(50),
	@StudyId				VARCHAR(200),
	@NewStructure			VARCHAR(1)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		SELECT
			B.[Name]						'processName',
			A.[Name]						'studyName',
			A.[Description]					'studyDescription',
			A.[TemplateId]					'templateId'
		FROM [dbo].[Study] A (NOLOCK)
		INNER JOIN Process B ON A.ProcessId = B.[Name]
		WHERE A.[VCC] = @VCC 
			AND A.[Name] = @StudyId
	END

	BEGIN
		SELECT
			[VCC]							'vcc',
			[StudyId]						'studyId',
			[TemplateId]					'templateId',
			[TemplateThemeId]				'templateThemeId',
			[ID]							'id',
			[Description]					'description',
			[Category1]						'category1',
			[Category2]						'category2',
			[Total]							'total',
			[Duration]						'duration',
			[Silence]						'silence',
			[Confidence]					'confidence',
			[CreatedDate]					'createdDate',
			[CreatedByUserId]				'createdByUserId',
			[LastModifiedDate]				'lastModifiedDate',
			[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[StudyResultSummary] (NOLOCK)
		WHERE [VCC] = @VCC 
			AND [StudyId] = @StudyId
	END

	IF(@NewStructure IS NULL)
	BEGIN
		SELECT
			A.[TemplateThemeId]									'templateThemeId',
			A.[TemplateThemeItemId]								'templateThemeItemId',
			ISNULL(D.[Query], A.[TemplateThemeItemId])			'query', -- Si es NULL se mostrara valor de TemplateThemeItem campo ID.
			ISNULL(C.[Channel], AI.[Channel])					'interactionType',
			-- REPLACE(A.[TranscriptionId], '_0_1', '')			'transcriptionId',

			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN REPLACE(A.[TranscriptionId], '_0_1', '') 
				ELSE AI.[ID] END								'transcriptionId',

			C.[Section]											'section',
			C.[Part]											'part',
			AI.[Folder]											'folder',
			AI.[Campaign]										'campaign',
			--ISNULL(C.[Agent], '')								'agent'
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[Agent], '') 
				ELSE ISNULL(AI.[FirstTakedAgent], '') END		'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsTranscribed], '') 
				ELSE ISNULL(AI.[IsTranscribed], '') END			'isTranscribed',
			CASE WHEN C.[Channel] IS NOT NULL
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsCancel], '') 
				ELSE ISNULL(AI.[IsCancel], '') END				'isCancel'
		FROM 
			[dbo].[StudyResultSummaryDetail] A (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK) 
				ON S.[VCC] = A.[VCC] 
					AND S.[Name] = A.[StudyId]
			INNER JOIN [dbo].[HistoricTemplateThemeItem] B (NOLOCK) 
				ON S.[TemplateId] = B.[TemplateId] 
					AND A.[TemplateThemeId] = B.[TemplateThemeId] 
					AND A.[TemplateThemeItemId] = B.[ID]
			
			LEFT JOIN [dbo].[Audio] C (NOLOCK)  -- (!)SE CAMBIO EL INNER POR LEFT PARA CONSIDER LAS TRANSCRIPCIONES DE CANALES ASINCRINOS
				ON A.[VCC] = C.[VCC]
					AND A.[TranscriptionId] = CONCAT(C.[ID], '_', C.[Section], '_', C.[Part])
			LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON S.[VCC] = PA.[VCC] 
					AND S.[ProcessId] = PA.[ProcessId] 
					AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])

			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON A.[TranscriptionId] = CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_'))
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = S.[VCC]
					AND PAI.[ProcessId] = S.[ProcessId]
					AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = A.[TranscriptionId]

			LEFT JOIN [dbo].[GenericQuery] D (NOLOCK) 
				ON B.[VCC] = D.[VCC] 
					AND  B.[ID] = D.[Name] -- Se agrega LEFT JOIN para poder mostrar.
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId
	END
	ELSE
	BEGIN
		-- ESTE BLOQUE NUNCA SE USA, EL UNICO LLAMADO DE LA FUNCION INSERTA DIRECTAMENTE NULL PARA LA VARIABLE @NewStructure
		SELECT
			A.[TemplateThemeId]									'templateThemeId',
			A.[TemplateThemeItemId]								'templateThemeItemId',
			D.[Query]											'query',
			ISNULL(C.[Channel], AI.[Channel])					'interactionType',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN A.[TranscriptionId] 
				ELSE AI.[ID] END								'transcriptionId',
			C.[Section]											'section',
			C.[Part]											'part',
			AI.[Folder]											'folder',
			AI.[Campaign]										'campaign',
			--ISNULL(C.[Agent], '')								'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[Agent], '') 
				ELSE ISNULL(AI.[FirstTakedAgent], '') END		'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsTranscribed], '') 
				ELSE ISNULL(AI.[IsTranscribed], '') END			'isTranscribed',
			CASE WHEN C.[Channel] IS NOT NULL
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsCancel], '') 
				ELSE ISNULL(AI.[IsCancel], '') END				'isCancel'
			
		FROM 
			[dbo].[StudyResultSummaryDetail] A (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK) 
				ON S.[VCC] = A.[VCC] 
					AND S.[Name] = A.[StudyId]
			INNER JOIN [dbo].[HistoricTemplateThemeItem] B (NOLOCK) 
				ON S.[TemplateId] = B.[TemplateId] 
					AND A.[TemplateThemeId] = B.[TemplateThemeId] 
					AND A.[TemplateThemeItemId] = B.[ID]
			
			LEFT JOIN [dbo].[Audio] C (NOLOCK) 
				ON A.[VCC] = C.[VCC]
					AND A.[TranscriptionId] = CONCAT(C.[ID], '_', C.[Section], '_', C.[Part])
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON S.[VCC] = PA.[VCC] 
					AND S.[ProcessId] = PA.[ProcessId] 
					AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
			
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON A.[TranscriptionId] = CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_'))
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = S.[VCC]
					AND PAI.[ProcessId] = S.[ProcessId]
					AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = A.[TranscriptionId]

			INNER JOIN [dbo].[GenericQuery] D (NOLOCK) 
				ON B.[VCC] = D.[VCC] 
					AND  B.[ID] = D.[Name]
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId
	END
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[ReportByDetailAgent]...';


GO


ALTER PROCEDURE [dbo].[ReportByDetailAgent] (
	@VCC varchar(50) = NULL, 
	@HistoricCampaign varchar(MAX) = NULL , 
	@Plan varchar(MAX) = NULL,
	@Format varchar(MAX), 
	@StartDate DateTime = NULL , 
	@EndDate DateTime = NULL , 
	@IdAuditor varchar(MAX) = NULL ,
	@IdAgente varchar(MAX) = NULL
) AS
  DECLARE @cols varchar(max) 
  DECLARE @query varchar(max)
  
  -- ReportByDetailAgent 'allegro','entrantes','Plan_2_nov01-0356','nov01-0356','20191001','20191201','isidoro','icagente3'
  SET NOCOUNT ON

  SELECT
    * INTO #TempEvaluationResult
  FROM (
  SELECT
	EP.[Instance]														'VCC',
    EP.Description														AS 'DescriptionPlan',
    EF.Description														AS 'DescriptionFormat',
    (
		GP.Description
		+ '-' 
		+ SGP.Description
		+ '-' 
		+ A.Title
	)																	AS 'Ability', --Collate SQL_Latin1_General_CP1253_CI_AI
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ISNULL(ER.Qualification, 0)											AS 'Qualification',
	AEP.[AutomaticScore],
	AEP.[ManualScore],
	--Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss')					AS 'EvaluationDate',
	--CAST(Format(AEP.[TimeStamp], 'yyyy-MM-dd hh:mm:ss') AS DATETIME)					AS 'EvaluationDate',
	AEP.[TimeStamp] AS 'EvaluationDate',
    ER.IdAuditor,
	EP.Evaluation_Mode	
  FROM EvaluationResult (NOLOCK) ER
  INNER JOIN HistoricEvaluationFormat EF
    ON ER.IdEvaluationFormat = EF.ID
  INNER JOIN HistoricAbility (NOLOCK) A
    ON A.[VCC] = ER.[Instance]
		AND A.ID = ER.IdAbility
  INNER JOIN EvaluationPlan (NOLOCK) EP
    ON EP.ID = ER.IdEvaluationPlan
	INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
		ON AEP.[Instance] = ER.[Instance]
			AND AEP.[IdEvaluationPlan] =  ER.[IdEvaluationPlan]
			AND AEP.[IdInteraction] = ER.[IdInteraction]
			AND AEP.[IdAuditor] =  ER.[IdAuditor]
  LEFT JOIN [HistoricGroup] (NOLOCK) GP
    ON GP.ID = ER.IdGroup
  LEFT JOIN HistoricSubGroup (NOLOCK) SGP
    ON SGP.ID = ER.IdSubGroup
  WHERE 
	ER.Instance LIKE CASE
		WHEN @VCC IS NOT NULL THEN @VCC
		ELSE ER.Instance
	  END
  AND 
	EF.Description IN(SELECT [Value] FROM [dbo].[Split](IIF(@Format IS NULL,EF.Description,@Format),','))
  AND 
	EP.Description IN(SELECT [Value] FROM [dbo].[Split](IIF(@Plan IS NULL,EP.Description,@Plan),','))
  AND 
    ER.CampaignDescription IN(SELECT [Value] FROM [dbo].[Split](IIF(@HistoricCampaign IS NULL,ER.CampaignDescription,@HistoricCampaign),','))
  AND 
    ER.AgentDescription IN(SELECT [Value] FROM [dbo].[Split](IIF(@IdAgente IS NULL,ER.AgentDescription,@IdAgente),','))
	
  AND 
    ER.IdAuditor IN(SELECT [Value] FROM [dbo].[Split](IIF(@IdAuditor IS NULL,ER.IdAuditor,@IdAuditor),','))

  AND AEP.[TimeStamp] >=
                          CASE
                            WHEN @StartDate IS NOT NULL THEN @StartDate
                            ELSE '19800101'
                          END
  AND AEP.[TimeStamp] <
                         CASE
                           WHEN @EndDate IS NOT NULL THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END
  --AND EP.[Status] = 7
  AND AEP.[Completed] = 1
	) a

	--select * from #TempEvaluationResult ORDER BY IdInteraction


  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability) 
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')

  --Select @cols
  IF @cols IS NOT NULL
  BEGIN

    DECLARE @type varchar(max)=(Select Top 1 Evaluation_Mode From #TempEvaluationResult)

    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
    --SELECT @type
	If @type = 'M'
	BEGIN
    SET @query = ' 
				Select p.[VCC]							AS [VCC],
						p.DescriptionPlan				As [EVALUATION_PLAN],
						p.DescriptionFormat				As [EVALUATION_FORMAT],
						p.AgentDescription				As [AGENT],
  						p.CampaignDescription			As [CAMPAIGN],
						p.IdInteraction					As [INTERACTION],
						p.EvaluationDate				As [EVALUATION_DATE],
						p.IdAuditor						As [AUDITOR],
						InteractionDuration				as [DURATION_TIME], 
						null							As [PHONE],
						InteractionDateStart			As [START_DATE],
						null							As [CATEGORY],
						(' + @Total + ')				As COLUMN_TOTAL_SCORE, 
						p.[AutomaticScore]				AS COLUMN_AUTOMATIC_SCORE,
						p.[ManualScore]					AS COLUMN_MANUAL_SCORE,
						' + @cols + ' 
					from 
				( select VCC,
							DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  AutomaticScore,
						  ManualScore,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock) 
				) as A On
				A.IdInteraction = p.IdInteraction '
    END
	ELSE 
	BEGIN
    SET @query = ' 
				Select p.[VCC]							AS [VCC],
						p.DescriptionPlan				As [EVALUATION_PLAN],
						p.DescriptionFormat				As [EVALUATION_FORMAT],
						p.AgentDescription				As [AGENT],
  						p.CampaignDescription			As [CAMPAIGN] ,
						p.IdInteraction					As [INTERACTION] ,
						p.EvaluationDate				As [EVALUATION_DATE],
						p.IdAuditor						As [AUDITOR],
						A.DurationTime					as [DURATION_TIME],
						A.Number						As [PHONE] ,
						A.StartDate						As [START_DATE] ,
						A.Category1						As [CATEGORY] ,
						(' + @Total + ')				As COLUMN_TOTAL_SCORE,
						p.[AutomaticScore]				AS COLUMN_AUTOMATIC_SCORE,
						p.[ManualScore]					AS COLUMN_MANUAL_SCORE,
						' + @cols + ' 
					from ( 
						select VCC,
								DescriptionPlan,
								DescriptionFormat,
								Ability,
								AgentDescription,
								CampaignDescription,
								IdInteraction,
								EvaluationDate,
								Qualification,
								AutomaticScore,
								ManualScore,
								IdAuditor			
							from #TempEvaluationResult
					) x pivot 
					( 
						 max(Qualification)
						for Ability in (' + @cols + ')
					) p 
					LEFT Join Audio as A 
						On A.[VCC] = p.[VCC]
							AND A.ID = p.IdInteraction'
	END
	--Print(@query)
    EXECUTE (@query)
    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    SELECT
						''				As [EVALUATION_PLAN],
						''				As [EVALUATION_FORMAT],
						''				As [AGENT],
  						''			    As [CAMPAIGN] ,
						''			 	As [INTERACTION] ,
						''				As [EVALUATION_DATE],
						''				As [AUDITOR]
  END
  
  SET NOCOUNT OFF
GO
PRINT N'Modificando [dbo].[ReportBySummaryAgent]...';


GO


ALTER PROCEDURE [dbo].[ReportBySummaryAgent] (
	@VCC varchar(50) = NULL, 
	@HistoricCampaign varchar(MAX) = NULL, 
	@Plan varchar(MAX) = NULL,
	@Format varchar(MAX) , 
	@StartDate DateTime = NULL , 
	@EndDate DateTime = NULL , 
	@IdAuditor varchar(MAX) = NULL ,
	@IdAgente varchar(MAX) = NULL
) AS
  DECLARE @cols varchar(max)
  DECLARE @query varchar(max)
  --ReportBySummaryAgent 'allegro','entrantes',NULL,'nov01-0356',NULL,NULL,NULL,NULL
  --SET @Format = 'nov01-0356'
  SET NOCOUNT ON
  
  SELECT
    * INTO #TempEvaluationResult
  FROM (
  SELECT
    EP.Description AS 'DescriptionPlan',
    EF.Description AS 'DescriptionFormat',
    GP.Description + '-' + SGP.Description + '-' + A.Title AS 'Ability',
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ER.Qualification,
    Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss') AS 'EvaluationDate',
    ER.IdAuditor,
    EP.Evaluation_Mode
  FROM EvaluationResult (NOLOCK) ER
  LEFT JOIN HistoricEvaluationFormat (NOLOCK) EF
    ON ER.IdEvaluationFormat = EF.ID
  LEFT JOIN HistoricAbility (NOLOCK) A
    ON A.ID = ER.IdAbility
  LEFT JOIN EvaluationPlan (NOLOCK) EP
    ON EP.ID = ER.IdEvaluationPlan
  LEFT JOIN [HistoricGroup] (NOLOCK) GP
    ON GP.ID = ER.IdGroup
  LEFT JOIN HistoricSubGroup SGP (NOLOCK)
    ON SGP.ID = ER.IdSubGroup
  WHERE 
   EF.Description IN(SELECT [Value] FROM [dbo].[Split](IIF(@Format IS NULL,EF.Description,@Format),','))
  AND ER.Instance LIKE CASE
    WHEN @VCC IS NOT NULL THEN @VCC
    ELSE ER.Instance
  END
  AND 
  EP.Description IN(SELECT [Value] FROM [dbo].[Split](IIF(@Plan IS NULL,EP.Description,@Plan),','))
  AND
  ER.CampaignDescription IN(SELECT [Value] FROM [dbo].[Split](IIF(@HistoricCampaign IS NULL,ER.CampaignDescription,@HistoricCampaign),','))
  AND 
  ER.AgentDescription IN(SELECT [Value] FROM [dbo].[Split](IIF(@IdAgente IS NULL,ER.AgentDescription,@IdAgente),','))
  AND 
  ER.IdAuditor IN(SELECT [Value] FROM [dbo].[Split](IIF(@IdAuditor IS NULL,ER.IdAuditor,@IdAuditor),','))
  AND ER.EvaluationDate >=
                          CASE
                            WHEN @StartDate IS NOT NULL THEN @StartDate
                            ELSE '19800101'
                          END
  AND ER.EvaluationDate <
                         CASE
                           WHEN @EndDate IS NOT NULL THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END
	) a

	
  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability)
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')
  
  IF @cols IS NOT NULL
  BEGIN
    ------
    DECLARE @type varchar(max) = (SELECT TOP 1
      Evaluation_Mode
    FROM #TempEvaluationResult)
	-------
    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')    
	-- ROUND(AVG(CAST(ER.Qualification AS float)), 2) AS 'Qualification',
    DECLARE @colavg varchar(max) = STUFF((SELECT DISTINCT
      ', ROUND(AVG(CAST(q.' + QUOTENAME(Ability) + ' AS float)), 2) As [' + Ability + ' Promedio]'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
	
	--SELECT @colavg
    IF @type = 'M'
    BEGIN
      SET @query = ' 
				Select 
				q.DescriptionPlan As   [EVALUATION_PLAN] ,
				q.DescriptionFormat As [EVALUATION_FORMAT] ,
				q.AgentDescription As  [AGENT] ,
				q.CampaignDescription As [CAMPAIGN] ,
				count(q.IdInteraction) As [AUDITS],
				sum(q.DurationTime) As [DURATION_TIME],
				ROUND(AVG(CAST(q.Note AS float)), 2) As [AVERAGE_SCORE],
				' + @colavg + ' From
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,InteractionDuration as DurationTime, 
				null As Number,InteractionDateStart As StartDate,null As Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock)
				) as A On
				A.IdInteraction=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription
				'
    END
    ELSE
    BEGIN
      SET @query = '
	
			    Select 
				q.DescriptionPlan As   [EVALUATION_PLAN] ,
				q.DescriptionFormat As [EVALUATION_FORMAT] ,
				q.AgentDescription As  [AGENT] ,
				q.CampaignDescription As [CAMPAIGN] ,
			    count(q.IdInteraction) As [AUDITS],
				sum(q.DurationTime) As [DURATION_TIME],
				ROUND(AVG(CAST(q.Note AS float)), 2) As [AVERAGE_SCORE],
				' + @colavg + '
				From 
				(Select p.DescriptionPlan,p.DescriptionFormat,p.AgentDescription,
  				p.CampaignDescription,p.IdInteraction,p.EvaluationDate,p.IdAuditor,
				A.DurationTime,A.Number,A.StartDate,A.Category1,(' + @Total + ') As Note, ' + @cols + ' from 
				( select DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join Audio as A On
				A.ID=p.IdInteraction)q
				Group By 
				q.DescriptionPlan,q.DescriptionFormat,q.AgentDescription,q.CampaignDescription'
    END
    --Print(@query)
    EXECUTE (@query)
    --Select * From @query
	

    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    DROP TABLE #TempEvaluationResult
    SELECT
						''				As [EVALUATION_PLAN],
						''				As [EVALUATION_FORMAT],
						''				As [AGENT],
  						''			    As [CAMPAIGN] 
  END
  
  SET NOCOUNT OFF
GO
PRINT N'Creando [dbo].[SaveHistoricEvaluationPlanData]...';


GO

CREATE PROCEDURE [dbo].[SaveHistoricEvaluationPlanData] (
	@VCC VARCHAR(50) = NULL,
	@FormatId VARCHAR(100) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	IF(NOT EXISTS(SELECT [ID] FROM [dbo].[HistoricEvaluationFormat] (NOLOCK) WHERE [ID] = @FormatId))
	BEGIN
	
	     INSERT INTO [dbo].[HistoricEvaluationFormat] 
            SELECT 
            EF.[Instance],
            EF.[ID],
            EF.[Description],
            EF.[type],
            EF.[EnvironmentType],
            EF.[MinAutomaticQualification],
            EF.[MinQualificationAcceptable],
            EF.[ManagementFormURL],
            EF.[Enabled],
            EF.[templateId]
            FROM [dbo].[EvaluationFormat] EF (NOLOCK) 
            WHERE [ID] = @FormatId AND [Instance] = @VCC


		 
			INSERT INTO [dbo].[HistoricAbilityEvaluationFormat]
			SELECT
				A.[Instance],
				A.[ID] ,
				A.[IdEvaluationFormat],
				A.[IdAbility],
				A.[IdGroup],
				A.[IdSubGroup],
				A.[Penalizes],
				A.[Score],
				A.[Order],
				A.[Conditional]
				FROM  [dbo].[AbilityEvaluationFormat] A (NOLOCK)
				JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = A.[Instance] AND EF.[ID] = A.[IdEvaluationFormat]
				WHERE EF.[ID] = @FormatId AND EF.[Instance] = @VCC


	END

	IF(NOT EXISTS(SELECT 
			ECF.[ID]
			FROM [dbo].[HistoricEvaluationFormatCustomField] ECF (NOLOCK)
			JOIN [dbo].[HistoricEvaluationFormat] EF (NOLOCK) 
			ON ECF.[VCC] = EF.[VCC] AND ECF.[EvaluationFormatId] = EF.[ID]
			WHERE EF.[ID] = @FormatId AND EF.[VCC] = @VCC))
	BEGIN
			INSERT INTO [dbo].[HistoricEvaluationFormatCustomField]
			SELECT 
			ECF.[VCC],
			ECF.[ID],
			ECF.[EvaluationFormatId],
			ECF.[CustomFieldId],
			ECF.[Order]
			FROM [dbo].[EvaluationFormatCustomField] ECF (NOLOCK)
			JOIN [dbo].[EvaluationFormat] EF (NOLOCK) 
			ON ECF.[VCC] = EF.[Instance] AND ECF.[EvaluationFormatId] = EF.[ID]
			WHERE EF.[ID] = @FormatId AND EF.[Instance] = @VCC
			GROUP BY
			ECF.[VCC],
			ECF.[ID],
			ECF.[EvaluationFormatId],
			ECF.[CustomFieldId],
			ECF.[Order]
	END

	IF(NOT EXISTS(SELECT 
			 C.[ID]
			FROM [dbo].[HistoricCustomField] C (NOLOCK)
			JOIN [dbo].[HistoricEvaluationFormatCustomField] FC (NOLOCK)
			ON C.[VCC] = FC.[VCC] AND C.[ID] = FC.[CustomFieldId]
			WHERE FC.[EvaluationFormatId] = @FormatId AND FC.[VCC] = @VCC))
	BEGIN
	INSERT INTO [dbo].[HistoricCustomField]
		SELECT 
			 C.[VCC],
			 C.[ID],
			 C.[Description],
			 C.[Type],
			 C.[Label]
			FROM [dbo].[CustomField] C (NOLOCK)
			JOIN [dbo].[EvaluationFormatCustomField] FC (NOLOCK)
			ON C.[VCC] = FC.[VCC] AND C.[ID] = FC.[CustomFieldId]
			WHERE FC.[EvaluationFormatId] = @FormatId AND FC.[VCC] = @VCC
			GROUP BY       
			 C.[VCC],
			 C.[ID],
			 C.[Description],
			 C.[Type],
			 C.[Label]
	END

	IF(NOT EXISTS(SELECT
			CR.[ID]
			FROM [dbo].[HistoricCustomFieldResult] CR (NOLOCK)
			JOIN [dbo].[HistoricCustomField] C (NOLOCK)
			ON CR.[VCC] = C.[VCC] AND CR.[CustomFieldId] = C.[ID]
			JOIN [dbo].[HistoricEvaluationFormatCustomField] FC (NOLOCK)
			ON C.[VCC] = FC.[VCC] AND C.[ID] = FC.[CustomFieldId]
			WHERE FC.[EvaluationFormatId] = @FormatId AND FC.[VCC] = @VCC))
	BEGIN
			INSERT INTO [dbo].[HistoricCustomFieldResult]
			SELECT
			CR.[VCC],
			CR.[ID],
			CR.[Description],
			CR.[Order],
			CR.[CustomFieldId]
			FROM [dbo].[CustomFieldResult] CR (NOLOCK)
			JOIN [dbo].[CustomField] C (NOLOCK)
			ON CR.[VCC] = C.[VCC] AND CR.[CustomFieldId] = C.[ID]
			JOIN [dbo].[EvaluationFormatCustomField] FC (NOLOCK)
			ON C.[VCC] = FC.[VCC] AND C.[ID] = FC.[CustomFieldId]
			WHERE FC.[EvaluationFormatId] = @FormatId AND FC.[VCC] = @VCC
			GROUP BY 
			CR.[VCC],
			CR.[ID],
			CR.[Description],
			CR.[Order],
			CR.[CustomFieldId]
	END

	IF(NOT EXISTS(SELECT 
				AFS.[VCC]
			FROM [dbo].[HistoricEvaluationFormatAttachedSignature] AFS (NOLOCK)
            WHERE AFS.[EvaluationFormatId] = @FormatId AND AFS.[VCC] = @VCC))
	BEGIN
			INSERT INTO 
			[dbo].[HistoricEvaluationFormatAttachedSignature]
			SELECT 
				AFS.[VCC],
				AFS.[Description],
				AFS.[Order],
				AFS.[EvaluationFormatId]
			FROM [dbo].[EvaluationFormatAttachedSignature] AFS (NOLOCK)
            WHERE AFS.[EvaluationFormatId] = @FormatId AND AFS.[VCC] = @VCC
	END

	
	IF(NOT EXISTS(SELECT
				CEF.[IdCampaign]
			FROM [dbo].[HistoricCampaignEvaluationFormat] CEF (NOLOCK) 
			WHERE CEF.[IdEvaluationFormat] = @FormatId AND CEF.[VCC] = @VCC))
	BEGIN
			INSERT INTO [dbo].[HistoricCampaignEvaluationFormat]
			SELECT
				CEF.[Instance],
				CEF.[IdEvaluationFormat],
				CEF.[IdCampaign]
			FROM [dbo].[CampaignEvaluationFormat] CEF (NOLOCK) 
			WHERE CEF.[IdEvaluationFormat] = @FormatId AND CEF.[Instance] = @VCC
			GROUP BY 
				CEF.[Instance],
				CEF.[IdEvaluationFormat],
				CEF.[IdCampaign]
	END


	IF(NOT EXISTS(
	SELECT G.[ID] FROM [dbo].[HistoricGroup] G (NOLOCK) 
    JOIN [dbo].[HistoricAbilityEvaluationFormat] A (NOLOCK)
			ON  A.[VCC] = G.[VCC] AND A.[IdGroup] = G.[ID]
            WHERE A.[IdEvaluationFormat] = @FormatId AND A.[VCC] = @VCC
	))
	BEGIN 
		        INSERT INTO [dbo].[HistoricGroup] 
				SELECT 
					G.[Instance] ,
					G.[ID],
					G.[Description] ,
					G.[Enabled] 
				FROM [dbo].[Group] G (NOLOCK)
				JOIN [dbo].[AbilityEvaluationFormat] A (NOLOCK)
				ON  A.[Instance] = G.[Instance] AND A.[IdGroup] = G.[ID]
				WHERE A.[IdEvaluationFormat] = @FormatId AND A.[Instance] = @VCC
				GROUP BY 
				G.[Instance] ,
				G.[ID],
				G.[Description] ,
				G.[Enabled] 
	END


	IF(NOT EXISTS(
	SELECT G.[ID] FROM [dbo].[HistoricSubGroup] G (NOLOCK) 
    JOIN [dbo].[HistoricAbilityEvaluationFormat] A (NOLOCK)
			ON  A.[VCC] = G.[VCC] AND A.[IdSubGroup] = G.[ID]
            WHERE A.[IdEvaluationFormat] = @FormatId AND A.[VCC] = @VCC
	))
	BEGIN 
		        INSERT INTO [dbo].[HistoricSubGroup] 
				SELECT 
					G.[Instance] ,
					G.[ID],
					G.[Description] ,
					G.[Enabled] 
				FROM [dbo].[SubGroup] G (NOLOCK)
				JOIN [dbo].[AbilityEvaluationFormat] A (NOLOCK)
				ON  A.[Instance] = G.[Instance] AND A.[IdSubGroup] = G.[ID]
				WHERE A.[IdEvaluationFormat] = @FormatId AND A.[Instance] = @VCC
				GROUP BY 
				    G.[Instance] ,
					G.[ID],
					G.[Description] ,
					G.[Enabled] 
	END

	IF(NOT EXISTS(
	SELECT AB.[ID] FROM [dbo].[HistoricAbility] AB (NOLOCK) 
    JOIN [dbo].[HistoricAbilityEvaluationFormat] A (NOLOCK)
			ON  A.[VCC] = AB.[VCC] AND A.[IdAbility] = AB.[ID]
            WHERE A.[IdEvaluationFormat] = @FormatId AND A.[VCC] = @VCC
	))
	BEGIN 
		        INSERT INTO [dbo].[HistoricAbility] 
				SELECT 
				A.[Instance],
                A.[ID],
                A.[Title],
                A.[Detail],
                A.[Type],
                A.[Binary],
                A.[NotApply],
                A.[Distribute],
                A.[AcceptComments],
                A.[Enabled],
                A.[AnalysisType],
                A.[Query],
                A.[QueryName],
                A.[Language],
                A.[IsNegative]
				FROM [dbo].[Ability] A (NOLOCK)
				JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
				ON  A.[Instance] = AEF.[Instance] AND AEF.[IdAbility] = A.[ID]
				WHERE AEF.[IdEvaluationFormat] = @FormatId AND A.[Instance] = @VCC
	END

   IF(NOT EXISTS(SELECT AQ.[ID] FROM [dbo].[HistoricAbilityQuery] AQ (NOLOCK)
                 JOIN [dbo].[HistoricAbilityEvaluationFormat] AEF (NOLOCK)
                 ON  AQ.[VCC] = AEF.[VCC] AND AEF.[IdAbility] = AQ.[AbilityId]
				 WHERE AEF.[IdEvaluationFormat] = @FormatId AND AQ.[VCC] = @VCC))
   BEGIN
		INSERT INTO [dbo].[HistoricAbilityQuery]
		SELECT 
			AQ.[ID],
			AQ.[VCC],
			AQ.[AbilityId],
			AQ.[QueryId],
			AQ.[QueryContent],
			AQ.[AcceptancePercentage],
			AQ.[Order]
		FROM [dbo].[AbilityQuery] AQ (NOLOCK)
		JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
		ON  AQ.[VCC] = AEF.[Instance] AND AEF.[IdAbility] = AQ.[AbilityId]
		WHERE AEF.[IdEvaluationFormat] = @FormatId AND AQ.[VCC] = @VCC
		GROUP BY 
		    AQ.[ID],
			AQ.[VCC],
			AQ.[AbilityId],
			AQ.[QueryId],
			AQ.[QueryContent],
			AQ.[AcceptancePercentage],
			AQ.[Order]
  END

  IF(NOT EXISTS( SELECT 
                AQE.[VCC]
                FROM [dbo].[HistoricAbilityQueryEntity] AQE (NOLOCK)
                JOIN [dbo].[HistoricAbilityQuery] AQ (NOLOCK)
                ON AQ.[VCC] = AQE.[VCC] AND AQE.[AbilityQueryId] = AQ.[ID]
                JOIN [dbo].[HistoricAbilityEvaluationFormat] AEF (NOLOCK)
                ON  AQ.[VCC] = AEF.[VCC] AND AEF.[IdAbility] = AQ.[AbilityId]
				WHERE AQ.[VCC] = @VCC AND AEF.[IdEvaluationFormat] = @FormatId))

			   INSERT INTO [dbo].[HistoricAbilityQueryEntity]
						    SELECT 
							AQE.[VCC],
							AQE.[AbilityQueryId],
							AQE.[EntityId],
							AQE.[EntityName],
							AQE.[AcceptancePercentage],
							AQE.[Order]
							FROM [dbo].[AbilityQueryEntity] AQE (NOLOCK)
							JOIN [dbo].[AbilityQuery] AQ (NOLOCK)
							ON AQ.[VCC] = AQE.[VCC] AND AQE.[AbilityQueryId] = AQ.[ID]
							JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
							ON  AQ.[VCC] = AEF.[Instance] AND AEF.[IdAbility] = AQ.[AbilityId]
							WHERE AQ.[VCC] = @VCC AND AEF.[IdEvaluationFormat] = @FormatId
							GROUP BY 
							AQE.[VCC],
							AQE.[AbilityQueryId],
							AQE.[EntityId],
							AQE.[EntityName],
							AQE.[AcceptancePercentage],
							AQE.[Order]
	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveHistoricStudyData]...';


GO

CREATE PROCEDURE [dbo].[SaveHistoricStudyData] (
	@VCC VARCHAR(50) =        NULL,
	@TemplateId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON
	  
	  IF(NOT EXISTS(SELECT 
				T.[Name]
			FROM [dbo].[HistoricTemplate] T (NOLOCK)
			WHERE T.[Name]=@TemplateId AND T.[VCC]=@VCC))
	  BEGIN
			INSERT INTO [dbo].[HistoricTemplate] 
			SELECT 
				T.[VCC],
				T.[Name],
				T.[Type],
				T.[Description],
				T.[Template],
				T.[Category]
			FROM [dbo].[Template] T (NOLOCK)
			WHERE T.[Name]=@TemplateId AND T.[VCC]=@VCC
	  END

	  IF(NOT EXISTS(SELECT
				TT.[ID]
			FROM [dbo].[HistoricTemplateTheme] TT (NOLOCK)
			WHERE TT.[TemplateId] = @TemplateId AND TT.[VCC]=@VCC))
	  BEGIN
	  INSERT INTO [dbo].[HistoricTemplateTheme]
			SELECT
				TT.[VCC],
				TT.[TemplateId],
				TT.[ID],
				TT.[Order],
				TT.[Description],
				TT.[Category1],
				TT.[Category2],
				TT.[AnalysisType],
				TT.[IsNegative]
			FROM [dbo].[TemplateTheme] TT (NOLOCK)
			WHERE TT.[TemplateId] = @TemplateId AND TT.[VCC]=@VCC
	  END


	  IF(NOT EXISTS(SELECT 
				TTI.[ID]
			FROM [dbo].[HistoricTemplateThemeItem] TTI (NOLOCK)
			WHERE TTI.[TemplateId] = @TemplateId AND TTI.[VCC]=@VCC))
	  BEGIN
			INSERT INTO [dbo].[HistoricTemplateThemeItem]
			SELECT 
				TTI.[VCC],
				TTI.[TemplateId],
				TTI.[TemplateThemeId],
				TTI.[ID],
				TTI.[AcceptancePercentage]
			FROM [dbo].[TemplateThemeItem] TTI (NOLOCK)
			WHERE TTI.[TemplateId] = @TemplateId AND TTI.[VCC]=@VCC
	  END

	  IF(NOT EXISTS(SELECT 
			TTIE.[EntityId]
		FROM [dbo].[HistoricTemplateThemeItemEntity] TTIE (NOLOCK)
		WHERE TTIE.[TemplateId] = @TemplateId AND TTIE.[VCC] = @VCC))
	  BEGIN
		INSERT INTO [dbo].[HistoricTemplateThemeItemEntity]
		SELECT 
			TTIE.[VCC],
			TTIE.[TemplateId],
			TTIE.[TemplateThemeId],
			TTIE.[TemplateThemeItemId],
			TTIE.[EntityId],
			TTIE.[EntityName],
			TTIE.[AcceptancePercentage],
			TTIE.[Order]
		FROM [dbo].[TemplateThemeItemEntity] TTIE (NOLOCK)
		WHERE TTIE.[TemplateId] = @TemplateId AND TTIE.[VCC] = @VCC
	  END

	  IF(NOT EXISTS(SELECT
				GTQ.[ID]
			FROM [dbo].[HistoricGenericTemplateQuery] GTQ (NOLOCK)
            WHERE GTQ.[TemplateId] = @TemplateId AND GTQ.[VCC] = @VCC))
	  BEGIN
	  INSERT INTO [dbo].[HistoricGenericTemplateQuery]
			SELECT
				GTQ.[VCC],
				GTQ.[TemplateId],
				GTQ.[ID],
				GTQ.[Query]
			FROM [dbo].[GenericTemplateQuery] GTQ (NOLOCK)
            WHERE GTQ.[TemplateId] = @TemplateId AND GTQ.[VCC] = @VCC
	  END
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[SaveEvaluationPlan] (
	@Instance Varchar(50) = NULL,
	@ID Varchar(50) = NULL,
	@Modality Varchar(50) = NULL,
	@DateFin Datetime = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@IdEvaluationFormat Varchar(50) = NULL,
	@TranscriptionLanguage VARCHAR(25) = NULL,
	@EnvironmentId VARCHAR(100) = NULL,
	@Description Varchar(200) = NULL,
	@Enabled Bit = NULL,

	@FilterByContent BIT = NULL,
	@FilterByContentPercentage NUMERIC(3,0) = NULL,
	@EvaluatePercentage NUMERIC(3,0) = NULL,
	@ProcessAndEvaluate BIT = NULL,
	@FilterByContentQueryName VARCHAR(50) = NULL,
	@FilterByContentQuery VARCHAR(1000) = NULL,
	@EvaluationStarted BIT = NULL,
	@ProcessId VARCHAR(50) = NULL,
	@Status	NUMERIC(2,0) = NULL,
	@Evaluation_Mode VARCHAR(10) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationPlan]
	SET
		[Modality] = @Modality,
		[DateFin] = @DateFin,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE(),
		[IdEvaluationFormat] = @IdEvaluationFormat,
		[TranscriptionLanguage] = @TranscriptionLanguage,
		[EnvironmentId] = @EnvironmentId,
		[Description] =@Description,
		[Enabled] = CASE WHEN @Enabled IS NULL THEN [Enabled] ELSE @Enabled END,
		[EvaluatePercentage] = @EvaluatePercentage,
		[ProcessAndEvaluate] = @ProcessAndEvaluate,
		[FilterByContent] = CASE WHEN @FilterByContent IS NULL THEN [FilterByContent] ELSE @FilterByContent END,
		[FilterByContentPercentage] = CASE WHEN @FilterByContentPercentage IS NULL THEN [FilterByContentPercentage] ELSE @FilterByContentPercentage END,
		[FilterByContentQueryName] = CASE WHEN @FilterByContentQueryName IS NULL THEN [FilterByContentQueryName] ELSE @FilterByContentQueryName END,
		[FilterByContentQuery] = CASE WHEN @FilterByContentQuery IS NULL THEN [FilterByContentQuery] ELSE @FilterByContentQuery END,
		
		[EvaluationStarted] = @EvaluationStarted,
		[ProcessId] = @ProcessId,
		[Status] = @Status,
		[Total] = CASE WHEN [Status] = 5 AND @Status = 1 THEN NULL ELSE [Total] END,
		[Progress] = CASE WHEN [Status] = 5 AND @Status = 1 THEN NULL ELSE [Progress] END,
		[Error] = CASE WHEN [Status] = 5 AND @Status = 1 THEN NULL ELSE [Error] END,
		[Percentage] = CASE WHEN [Status] = 5 AND @Status = 1 THEN NULL ELSE [Percentage] END,
		[Evaluation_Mode] = @Evaluation_Mode
	WHERE [Instance] = @Instance
    AND [ID] = @ID

    IF @@ROWCOUNT = 0
    BEGIN 
	    		INSERT INTO [EvaluationPlan] (
				[Instance],[ID],
				[Modality], [DateFin], [CreatedDate],
				[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId],
				[TimeStamp], [IdEvaluationFormat], [TranscriptionLanguage],
				[EnvironmentId], [Description], [Enabled],
				[FilterByContent], [FilterByContentPercentage], [EvaluatePercentage], [ProcessAndEvaluate], [FilterByContentQueryName], [FilterByContentQuery], [EvaluationStarted], [ProcessId],
				[Status],[Evaluation_Mode]
				)
			   VALUES (
				@Instance,@ID,
				@Modality, @DateFin, @CreatedDate,
				@CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId,
				GETUTCDATE(), @IdEvaluationFormat, @TranscriptionLanguage,
				@EnvironmentId, @Description, 1,
				@FilterByContent, @FilterByContentPercentage, @EvaluatePercentage, @ProcessAndEvaluate, @FilterByContentQueryName, @FilterByContentQuery, @EvaluationStarted, @ProcessId,
				@Status, @Evaluation_Mode
			   )
			   
			 EXEC [dbo].[SaveHistoricEvaluationPlanData] @Instance,@IdEvaluationFormat
    END

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveStudy]...';


GO

ALTER PROCEDURE [dbo].[SaveStudy] (
	@VCC Varchar(50) = NULL, 					@ProcessId Varchar(50) = NULL,				@TemplateId Varchar(50) = NULL,
	@Name Varchar(200) = NULL,					@Description Varchar(50) = NULL,			@Status Float = NULL,
	@Type VARCHAR(50) = NULL,					@CreatedDate Datetime = NULL,               @CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,			@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [Study]
	SET [Name] = @Name,
		[Description] = @Description,
		[Status] = @Status,
		[Type] = @Type,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [ProcessId] = @ProcessId
	AND [TemplateId] =@TemplateId
	AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Study] (
			[VCC], [ProcessId], [TemplateId], 
			[Name], [Description], [Status],
			[Type],	[CreatedDate], [CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @ProcessId, @TemplateId,
			@Name, @Description, @Status,
			@Type, @CreatedDate, @CreatedByUserId, @LastModifiedDate, 
			@LastModifiedByUserId, GETUTCDATE()
		)
		EXEC [dbo].[SaveHistoricStudyData] @VCC,@TemplateId
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';
