PRINT N'Modificando [dbo].[GetCSVSummaryInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetCSVSummaryInteractions] 
(
	@VCC					VARCHAR(50) = NULL,
	@StartDate				DATETIME = '1980-01-01T00:00:00',
    @EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@MinDuration			INT = 0,
    @MaxDuration			INT = 100000,
    @Campaigns				VARCHAR(MAX) = NULL,
 	@Agents					VARCHAR(MAX) = NULL,
   	@Origins				VARCHAR(100) = NULL,
	@DispositionCodes		VARCHAR(MAX) = NULL,
	@InteractionIds         VARCHAR(MAX) = NULL,
	--@Evaluated              VARCHAR(MAX) = NULL,
	@IsSummary				BIT = 0								-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO
) 
AS
BEGIN
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NULL OR @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NULL OR @EndHour = '') SET @EndHour = '23:59:59'

	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE MINIMO Y MAXIMO
	IF (@MinDuration IS NULL OR @MinDuration = '') SET @MinDuration = 0
	IF (@MaxDuration IS NULL OR @MaxDuration = '') SET @MaxDuration = 100000
	
	-- DECLARAMOS UN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';
    DECLARE @FILTERS_OPTIONAL_PART  VARCHAR(MAX) = '';
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = '';
   -- DECLARE @QUERY_JOIN            VARCHAR(MAX) = '';

	-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
	IF @IsSummary = 1 
	BEGIN
		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
		SET @SQL_SELECT_0 += '
			SELECT ''CALL''											AS ''interactionType'', 
					COUNT(DISTINCT PCT.[ID])						AS ''totalInteractions'',
					COUNT(*)										AS ''details'',
					ISNULL(SUM(PCT.[DurationTime]), 0)				AS ''totalAttentionTime''
		'

		-- SETTEAMOS EL SELECT A LA VARIABLE FINAL
		SET @SQL_SELECT = @SQL_SELECT_0
	END
	ELSE
	BEGIN
		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
		SET @SQL_SELECT_1 += '
			SELECT PCT.[ID]											AS ''ID'',
					PCT.[Number]									AS ''Number'',
					PCT.[Gender]									AS ''Gender'',
					PCT.[SilenceTime]								AS ''SilenceTime'',
					PCT.[DurationTime]								AS ''DurationTime'',
					PCT.[Category1]									AS ''Category1'',
					PCT.[Category2]									AS ''Category2'',
					PCT.[Category3]									AS ''Category3'',
					PCT.[Description]								AS ''Description'',
					PCT.[Campaign]									AS ''Campaign'',
					PCT.[Agent]										AS ''Agent'',
					PCT.[Direction]									AS ''Direction'',
					CONVERT(VARCHAR, PCT.[StartDate], 120)			AS ''StartDate'',
					CONVERT(VARCHAR, PCT.[EndDate], 120)			AS ''EndDate'',
					PCT.[DispositionCode]							AS ''DispositionCode'',
					PCT.[RelativePath]								AS ''RelativePath'',
					PCT.[FileName]									AS ''FileName''
		'

		-- SETTEAMOS EL SELECT A LA VARIABLE FINAL
		SET @SQL_SELECT = @SQL_SELECT_1
	END
	
	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += ' FROM [#ProcessCsvTemp] PCT '

	-- FILTRO POR INTERACCIONES EVALUADAS O NO
	/*IF(@Evaluated IS NOT NULL AND @Evaluated <> '')
	  BEGIN 
	   DECLARE @EvaluatedTable TABLE (Val BIT)
	   INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')
       -- SOLAMENTE SI ES SI O NO
       IF((SELECT COUNT(Val) FROM @EvaluatedTable) = 1 )
       BEGIN
          IF((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
           BEGIN 
               SET @QUERY_JOIN = ' JOIN [dbo].[AuditorEvaluationPlan] AEP ON (AEP.[IdInteraction] = PCT.[ID] AND AEP.[Completed]=1 ) '
           END
          ELSE  --Si es No
           BEGIN
               SET @QUERY_JOIN = ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP ON (AEP.[IdInteraction] = PCT.[ID] AND AEP.[Completed]=1 ) '
               SET @FILTERS_OPTIONAL_PART += ' AND AEP.[IdInteraction] IS NULL '
           END
       END
       
	 END*/
	-- FIN FILTRO INTERACCIONES EVALUADAS
	

	-- ARMAMOS LA PARTE DE FILTROS
	SET @FILTERS_FIXED_PART = ' WHERE PCT.[ID] IS NOT NULL ';
    SET @FILTERS_OPTIONAL_PART += '
				AND PCT.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' 
				AND PCT.[DurationTime] BETWEEN ' + (SELECT CONVERT(VARCHAR(10), @MinDuration)) + ' AND ' + (SELECT CONVERT(VARCHAR(10), @MaxDuration)) + ' ';

	-- CONTINUAMOS CON LOS DEMAS FILTROS RECIBIDOS
	IF (@Campaigns IS NOT NULL AND @Campaigns != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND PCT.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	
	IF (@Agents IS NOT NULL AND @Agents != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND PCT.[Agent] IN (SELECT Value FROM [dbo].[split](''' + @Agents + ''','','')) '
	
	IF (@Origins IS NOT NULL AND @Origins != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND PCT.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origins + ''','','')) '
	
	IF (@DispositionCodes IS NOT NULL AND @DispositionCodes != '') 
		--SET @FILTERS_OPTIONAL_PART += 'AND PCT.[DispositionCode] IN (SELECT Value FROM [dbo].[split](''' + @DispositionCodes + ''','','')) '
		SET @FILTERS_OPTIONAL_PART += ' 
			AND (
				(CONCAT(PCT.[Campaign], ''_'', ISNULL(CONVERT(VARCHAR(4), PCT.[DispositionCode]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @DispositionCodes + ''','',''))) 
				OR
				(PCT.[Description] IN (SELECT Value FROM [dbo].[split](''' + @DispositionCodes + ''','','')))
			) '

	-- PARA EL CASO EN QUE HORA DE INICIO Y FIN NO SEAN NULL
	IF @StartHour IS NOT NULL AND @EndHour IS NOT NULL
	BEGIN
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
			SET @FILTERS_OPTIONAL_PART += 'AND CAST(PCT.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
			SET @FILTERS_OPTIONAL_PART += 'AND CAST(PCT.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO NO SEA NULL Y FIN SEA NULL
	ELSE IF @StartHour IS NOT NULL AND @EndHour IS NULL
	BEGIN
		SET @FILTERS_OPTIONAL_PART += 'AND CAST(PCT.[EndDate] AS TIME) > ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO SEA NULL Y FIN NO SEA NULL
	ELSE IF @StartHour IS NULL AND @EndHour IS NOT NULL
	BEGIN
		SET @FILTERS_OPTIONAL_PART += 'AND CAST(PCT.[EndDate] AS TIME) < ''' + @EndHour + ''' '
	END

    IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
    BEGIN
         SET @FILTERS_OPTIONAL_PART = '';
         --SET @QUERY_JOIN = '';
	     SET @FILTERS_EXCLUDING_PART = ' AND PCT.[ID] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
	END	  
	-- ELIMINAMOS LA TABLA TEMPORAL DESPUES DE EJECUTAR EL QUERY
	SET @SQL_EXTRA += ' DROP TABLE [#ProcessCsvTemp] '
	
	-- UNIMOS LAS PARTES DEL QUERY
	--SET @SQL_SELECT += @SQL_FROM + @QUERY_JOIN + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA;
    SET @SQL_SELECT += @SQL_FROM  + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA;
	-- EJECUTAMOS LA CONSULTA

	EXEC (@SQL_SELECT)
	
END
GO
PRINT N'Modificando [dbo].[GetEvaluationResults]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationResults] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL,
	@AuditorId VARCHAR(50) = NULL
) 
AS
BEGIN
	SET NOCOUNT ON

	-- SP PARA SOLICITAR LOS RESULTADOS DE LA EVALUACION DE UNA INTERACCION POR VCC, PLAN Y AUDITOR 
	SELECT ER.[IdAbility]							'idAbility',
			A.[Type]								'abilityType',
			ER.[Qualification]						'qualification',
			ER.[ScoreDescription]					'scoreDescription',
			ER.[Comment]                            'comments',
			ER.[EvaluationDate]						'evaluationDate',
			ER.[AbilityOrder]						'abilityOrder',
			ER.[LastModifiedByUserId]				'lastModifiedByUserId',
			ER.[LastModifiedDate]					'lastModifiedDate'
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		LEFT JOIN [dbo].[Ability] A (NOLOCK) 
			ON A.[Instance] = ER.[Instance]
				AND A.[ID] = ER.[IdAbility]
		WHERE ER.[Instance] = @VCC 
			AND ER.[IdEvaluationPlan] = @EvaluationPlanId
			AND ER.[IdInteraction] = @InteractionId
			AND ER.[IdAuditor] = @AuditorId
		ORDER BY ER.[AbilityOrder] ASC
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetI6InteractionAudios]...';


GO
ALTER PROCEDURE [dbo].[GetI6InteractionAudios] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL
) AS 
BEGIN
	-- BUSCAMOS LOS AUDIOS DE LA INTERACCION
	SELECT [ID]									'id',
			[Section]							'section',
			[Part]								'part',
			[Agent]								'agent',
			[Format]							'format'
		FROM [dbo].[Audio] A (NOLOCK)
		WHERE A.[VCC] = @VCC
			AND A.[ID] = @InteractionId
		ORDER BY A.[Section] ASC,  A.[Part] ASC
END
GO
PRINT N'Modificando [dbo].[LaunchAudioConverter]...';


GO
ALTER PROCEDURE [dbo].[LaunchAudioConverter] (
	@VCC VARCHAR(50) = NULL, 
	@APP_PATH VARCHAR(250) = NULL,
	@INPUT_FILE_PATH VARCHAR(250) = NULL, 
	@OUTPUT_FOLDER_PATH VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- ASEGURARSE DE QUE LA CARPETA DE RED DEL FTP ES VISIBLE PARA EL USUARIO DE SISTEMA DE SQL SERVER (TOQUE OL)
	-- EXEC xp_cmdshell 'net use L: \\10.205.31.121\Speech_Analytics$'

	-- CREAMOS UNA VARIABLE PARA ARMAR EL COMANDO
	DECLARE @COPY_TO_LOCAL_COMMAND VARCHAR(1000) = NULL
	DECLARE @COPY_TO_ORIGINAL_COMMAND VARCHAR(1000) = NULL
	DECLARE @DIARIZATE_COMMAND VARCHAR(1000) = NULL
	DECLARE @DELETE_FROM_LOCAL_INPUT VARCHAR(1000) = NULL
	DECLARE @DELETE_FROM_LOCAL_OUTPUT VARCHAR(1000) = NULL

	DECLARE @LOCAL_C_INPUT_FOLDER VARCHAR(200) = @APP_PATH + '/input'
	DECLARE @LOCAL_C_OUTPUT_FOLDER VARCHAR(200) = @APP_PATH + '/output'
	DECLARE @INPUT_FILE_NAME VARCHAR(250) = NULL

	--SET @COMMAND = 'C:/diarization/inConcertDiarization/inConcertDiarization.exe -i G:/Ftp_Volcado/Repositorio/diarization/inConcertDiarization/source/input/ENTRANTE.wav -o G:/Ftp_Volcado/Repositorio/diarization/inConcertDiarization/source/output -d 1'
	-- xp_cmdshell 'C:\diarization\inConcertDiarization\inConcertDiarization.exe -i C:\diarization\inConcertDiarization\source\input\ENTRANTE.wav -o C:\diarization\inConcertDiarization\source\output -d 1';
	
	-- CREAMOS UNA CTE PARA SEPARAR LAS PARTES DE LA RUTA DE INPUT
	;WITH CTE_INPUT_SPLIT AS (
		SELECT Value 'VAL', 
				ROW_NUMBER() OVER (ORDER BY (SELECT 1)) 'RN' 
			--FROM STRING_SPLIT('G:/Ftp_Volcado/Repositorio/diarization/inConcertDiarization/source/input/ENTRANTE.wav','/')
			FROM STRING_SPLIT(@INPUT_FILE_PATH, '/')
	)

	-- GUARDAMOS EN VARIABLE EL NOMBRE DEL ARCHIVO INPUT
	SELECT TOP 1 @INPUT_FILE_NAME = [VAL] 
		FROM CTE_INPUT_SPLIT 
		ORDER BY [RN] DESC

	-- COMPIAMOS EL ARCHIVO A LA CARPEA DE INPUT CUANDO LAS RUTAS SON DIFERENTES
	IF @INPUT_FILE_PATH <> (@LOCAL_C_INPUT_FOLDER + '/' + @INPUT_FILE_NAME)
	BEGIN
		-- COPIAMOS EL ARCHIVO INPUT DE LA RUTA RECIBIDA A LA CARPETA INPUT LOCAL
		SET @COPY_TO_LOCAL_COMMAND = 'copy "' + @INPUT_FILE_PATH + '" "' +  @LOCAL_C_INPUT_FOLDER + '/' + @INPUT_FILE_NAME + '" '
		SET @COPY_TO_LOCAL_COMMAND = REPLACE(@COPY_TO_LOCAL_COMMAND, '/', '\')
	
		-- EJECUTAMOS EL COMANDO
		EXEC('xp_cmdshell ''' +  @COPY_TO_LOCAL_COMMAND + '''')
	END
	ELSE
	BEGIN
		SELECT 1
	END

	-- ARMAMOS EL COMANDO QUE MUEVE A LA CARPETA LOCAL Y DIARIZAMOS
	--SET @COMMAND = @APP_PATH + '/inConcertDiarization.exe -i ' + @INPUT_FILE_PATH + ' -o ' + @OUTPUT_FOLDER_PATH + ' -d 1';
	--SET @DIARIZATE_COMMAND = 'cd ' + @LOCAL_C_FOLDER + ' & ' + @APP_PATH + '/inConcertDiarization.exe -i input/' + @INPUT_FILE_NAME + ' -o output '
	SET @DIARIZATE_COMMAND = 'cd ' + @APP_PATH + ' & inConcertDiarization.exe -i input/' + @INPUT_FILE_NAME + ' -o output -d 1'
	
	-- EJECUTAMOS EL COMANDO
	EXEC('xp_cmdshell ''' +  @DIARIZATE_COMMAND + '''')

	-- COMPIAMOS EL ARCHIVO A LA CARPEA DE INPUT CUANDO LAS RUTAS SON DIFERENTES
	IF @INPUT_FILE_PATH <> (@LOCAL_C_INPUT_FOLDER + '/' + @INPUT_FILE_NAME)
	BEGIN
		-- COPIAMOS EL ARCHIVO OUTPUT DE LA RUTA LOCAL A LA CARPETA OUTPUT RECIBIDA
		SET @COPY_TO_ORIGINAL_COMMAND = 'move "' + @LOCAL_C_OUTPUT_FOLDER + '/' + @INPUT_FILE_NAME + '" "' +  @OUTPUT_FOLDER_PATH + '/' + @INPUT_FILE_NAME + '" '
		SET @COPY_TO_ORIGINAL_COMMAND = REPLACE(@COPY_TO_ORIGINAL_COMMAND, '/', '\')

		-- EJECUTAMOS EL COMANDO
		EXEC('xp_cmdshell ''' +  @COPY_TO_ORIGINAL_COMMAND + '''')

		-- REMOVEMOS LOS ARCHIVOS DE INPUT Y OUTPUT LOCAL
		SET @DELETE_FROM_LOCAL_INPUT = 'del "' + @LOCAL_C_INPUT_FOLDER + '/' + @INPUT_FILE_NAME + '" '
		SET @DELETE_FROM_LOCAL_OUTPUT = 'del "' + @LOCAL_C_OUTPUT_FOLDER + '/' + @INPUT_FILE_NAME + '" '
	
		SET @DELETE_FROM_LOCAL_INPUT = REPLACE(@DELETE_FROM_LOCAL_INPUT, '/', '\')
		SET @DELETE_FROM_LOCAL_OUTPUT = REPLACE(@DELETE_FROM_LOCAL_OUTPUT, '/', '\')
	
		EXEC('xp_cmdshell ''' +  @DELETE_FROM_LOCAL_INPUT + '''')
		--EXEC('xp_cmdshell ''' +  @DELETE_FROM_LOCAL_OUTPUT + '''')
	END

	--EXEC xp_cmdshell 'net use L: /delete /y' -- TOQUE OL DESCARTADO

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveI6InteractionAudio]...';


GO
ALTER PROCEDURE [dbo].[SaveI6InteractionAudio] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@OldSection				INT = NULL,
	@OldPart				INT = NULL,
	@NewSection				INT = NULL,
	@NewPart				INT = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@Format					VARCHAR(10) = NULL
) AS 
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UNA VARIABLE PARA AYUDAR A LA ACTUALIZACION
		DECLARE @NEED_I6_UPDATE BIT = 1
		DECLARE @AGENT_NAME VARCHAR(100) = NULL -- NOMBRE DEL AGENTE

		-- ASIGNAMOS EL VALOR ACTUALIZADO DEL FLAG
		SELECT @NEED_I6_UPDATE = A.[NeedI6Update]
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[ID] = @InteractionId
				AND A.[Section] = @OldSection
				AND A.[Part] = @OldPart

		-- EN CASO REQUIERAN ACTUALIZACION POR UNICA VEZ
		IF @NEED_I6_UPDATE = 1
		BEGIN
			-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL AGENTE
			SELECT @AGENT_NAME = A.[Name]
				FROM [dbo].[Agent] A (NOLOCK)
				WHERE A.[VCC] = @VCC
					AND A.[AgentId] = @AgentId

			-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA AUDIO
			UPDATE [dbo].[Audio] 
				SET [Section] = @NewSection,
					[Part] = @NewPart,
					[Agent] = @AgentId,
					[AgentName] = @AGENT_NAME,
					[Format] = @Format,
					[NeedI6Update] = 0
				WHERE [VCC] = @VCC
					AND [ID] = @InteractionId
					AND [Section] = @OldSection
					AND [Part] = @OldPart

			-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA PROCESSAUDIO
			UPDATE [dbo].[ProcessAudio]
				SET [Section] = @NewSection,
					[Part] = @NewPart
				WHERE [VCC] = @VCC
					AND [AudioId] = @InteractionId
					AND [Section] = @OldSection
					AND [Part] = @OldPart 

			-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA INTERACTIONEVALUATIONPLAN
			UPDATE [dbo].[InteractionEvaluationPlan] 
				SET [InteractionSection] = @NewSection,
					[InteractionPart] = @NewPart,
					[IdAgent] = @AgentId,
					[AgentName] = @AGENT_NAME,
					[InteractionFormat] = @Format
				WHERE [Instance] = @VCC
					AND [IdInteraction] = @InteractionId
					AND [InteractionSection] = @OldSection
					AND [InteractionPart] = @OldPart 
		END
			
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';


GO
