PRINT N'Iniciando recompilación de la tabla [dbo].[Process]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Process] (
    [VCC]                  VARCHAR (50)    NOT NULL,
    [Name]                 VARCHAR (50)    NOT NULL,
    [Description]          VARCHAR (50)    NULL,
    [ClientId]             VARCHAR (50)    NULL,
    [Total]                INT             NULL,
    [Progress]             INT             NULL,
    [Error]                INT             NULL,
    [Percentage]           FLOAT (53)      NULL,
    [StatusDescription]    VARCHAR (MAX)   NULL,
    [Status]               VARCHAR (50)    NULL,
    [Type]                 VARCHAR (50)    NULL,
    [StartDate]            DATETIME        NULL,
    [EndDate]              DATETIME        NULL,
    [MinDurationTime]      NUMERIC (18, 2) NULL,
    [MaxDurationTime]      NUMERIC (18, 2) NULL,
    [Language]             VARCHAR (25)    NULL,
    [DictionaryId]         VARCHAR (50)    NULL,
    [Environment]          VARCHAR (50)    NULL,
    [QueryId]              VARCHAR (50)    NULL,
    [QueryDataId]          VARCHAR (50)    NULL,
    [QueryDataIdDate]      DATETIME        NULL,
    [BatchScheduleId]      VARCHAR (50)    CONSTRAINT [DF_Process_IsScheduled] DEFAULT ((0)) NULL,
    [CreatedDate]          DATETIME        NULL,
    [CreatedByUserId]      VARCHAR (50)    NULL,
    [LastModifiedDate]     DATETIME        NULL,
    [LastModifiedByUserId] VARCHAR (50)    NULL,
    [TimeStamp]            DATETIME        NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Process_11] PRIMARY KEY CLUSTERED ([VCC] ASC, [Name] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Process])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_Process] ([VCC], [Name], [Description], [ClientId], [Total], [Progress], [Error], [Percentage], [StatusDescription], [Status], [Type], [StartDate], [EndDate], [MinDurationTime], [MaxDurationTime], [Language], [DictionaryId], [Environment], [QueryId], [QueryDataId], [QueryDataIdDate], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [Name],
                 [Description],
                 [ClientId],
                 [Total],
                 [Progress],
                 [Error],
                 [Percentage],
                 [StatusDescription],
                 [Status],
                 [Type],
                 [StartDate],
                 [EndDate],
                 [MinDurationTime],
                 [MaxDurationTime],
                 [Language],
                 [DictionaryId],
                 [Environment],
                 [QueryId],
                 [QueryDataId],
                 [QueryDataIdDate],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[Process]
        ORDER BY [VCC] ASC, [Name] ASC;
    END

DROP TABLE [dbo].[Process];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Process]', N'Process';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Process_11]', N'PK_Process_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[ProcessFilter]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_ProcessFilter] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [ProcessId]            VARCHAR (50)  NOT NULL,
    [Key]                  VARCHAR (50)  NOT NULL,
    [Value]                VARCHAR (250) NOT NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_ProcessFilter1] PRIMARY KEY CLUSTERED ([VCC] ASC, [ProcessId] ASC, [Key] ASC, [Value] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[ProcessFilter])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_ProcessFilter] ([VCC], [ProcessId], [Key], [Value], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [ProcessId],
                 [Key],
                 [Value],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[ProcessFilter]
        ORDER BY [VCC] ASC, [ProcessId] ASC, [Key] ASC, [Value] ASC;
    END

DROP TABLE [dbo].[ProcessFilter];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_ProcessFilter]', N'ProcessFilter';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_ProcessFilter1]', N'PK_ProcessFilter', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Creando [dbo].[BatchSchedule]...';


GO
CREATE TABLE [dbo].[BatchSchedule] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [Id]                   VARCHAR (50)  NOT NULL,
    [BatchType]            VARCHAR (50)  NOT NULL,
    [Frequency]            VARCHAR (50)  NULL,
    [Weekday]              INT           NULL,
    [Monthday]             INT           NULL,
    [DaysInterval]         INT           NULL,
    [HoursInterval]        INT           NULL,
    [StartDate]            DATETIME      NULL,
    [EndDate]              DATETIME      NULL,
    [FirstExecutionDate]   DATETIME      NULL,
    [LastExecutionDate]    DATETIME      NULL,
    [FinalExecutionDate]   DATETIME      NULL,
    [BatchData]            VARCHAR (MAX) NULL,
    [ProcessFiltersId]     VARCHAR (50)  NULL,
    [Status]               VARCHAR (50)  NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [PK_BatchSchedule] PRIMARY KEY CLUSTERED ([VCC] ASC, [Id] ASC, [BatchType] ASC)
);


GO
PRINT N'Creando [dbo].[BatchScheduleExecution]...';


GO
CREATE TABLE [dbo].[BatchScheduleExecution] (
    [VCC]                  VARCHAR (50) NOT NULL,
    [Id]                   VARCHAR (50) NOT NULL,
    [BatchScheduleId]      VARCHAR (50) NULL,
    [BatchId]              VARCHAR (50) NULL,
    [ExecutionDate]        DATETIME     NULL,
    [Order]                INT          NULL,
    [Status]               VARCHAR (50) NULL,
    [CreatedByUserId]      VARCHAR (50) NULL,
    [CreatedDate]          DATETIME     NULL,
    [LastModifiedByUserId] VARCHAR (50) NULL,
    [LastModifiedDate]     DATETIME     NULL,
    [TimeStamp]            DATETIME     NULL,
    CONSTRAINT [PK_BatchScheduleExecution] PRIMARY KEY CLUSTERED ([VCC] ASC, [Id] ASC)
);


GO
PRINT N'Modificando [dbo].[FinishedBatchClose]...';


GO
ALTER PROCEDURE [dbo].[FinishedBatchClose](
	@VCC VARCHAR(50) = NULL,
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET NOCOUNT ON

	-- VERIFICAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
	IF @VCC IS NULL OR @BatchTypeName IS NULL OR @BatchTypeId IS NULL
		-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
		RAISERROR('DATABABASE_ERROR_MISSING_PARAMETERS', 16, 16)

	--SELECT * FROM [dbo].[Batch] 
	UPDATE [dbo].[Batch] 
		SET [FinishReported] = 1
			,[LastModifiedDate] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [BatchTypeName] = @BatchTypeName 
			AND [BatchTypeId] = @BatchTypeId

	-- SEGUN EL BATCHTYPENAME ACTUALIZAMOS EL STATUS DE LA TABLA DEL BATCH
	IF @BatchTypeName = 'TRANSCRIPTION'
	BEGIN
		UPDATE [dbo].[Process] 
			SET [Status] = CASE WHEN ([Total] - ISNULL([Error], 0)) > ISNULL([Error], 0) THEN 'COMPLETE'
							WHEN ([Total] - ISNULL([Error], 0)) < ISNULL([Error], 0) THEN 'FAILED' END
				,[StatusDescription] = CASE WHEN ISNULL([Error], 0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN ISNULL([Error], 0) = 0 THEN 'COMPLETED' END
			WHERE [VCC] = @VCC
				AND [Name] = @BatchTypeId
				AND [Percentage] = 1

		-- DECLARAMOS UNA VARIABLE PARA EL ID DE AGENDA
		DECLARE @SCHEDULE_BATCH_ID VARCHAR(50)

		SELECT @SCHEDULE_BATCH_ID = P.[BatchScheduleId]
			FROM [dbo].[Process] P (NOLOCK)
			WHERE P.[VCC] =  @VCC
				AND P.[Name] = @BatchTypeId

		IF @SCHEDULE_BATCH_ID IS NOT NULL
		BEGIN
			-- ACTUALIZAMOS LA EJECUCION EN CASO SEA UN PROCESS AGENDADO
			UPDATE BSE 
				SET BSE.[Status] = P.[StatusDescription],
					BSE.[LastModifiedByUserId] = 'system',
					BSE.[LastModifiedDate] = GETUTCDATE()
				FROM [dbo].[BatchScheduleExecution] BSE (NOLOCK)
				INNER JOIN [dbo].[Process] P (NOLOCK)
					ON P.[VCC] = BSE.[VCC]
						AND P.[Name] = BSE.[BatchId]
				WHERE BSE.[VCC] = @VCC
					AND P.[Name] = @BatchTypeId
					AND P.[BatchScheduleId] IS NOT NULL
			
			-- DECLARAMOS UNA VARIABLE PARA CONTABILIZAR LAS EJECUCIONES AUN NO TERMINADAS
			DECLARE @SCHEDULE_EXECUTIONS INT = 0


			SELECT @SCHEDULE_EXECUTIONS = COUNT(BSE.[Id]) 
				FROM [dbo].[BatchScheduleExecution] BSE (NOLOCK)
				WHERE BSE.[VCC] = @VCC
					AND BSE.[BatchScheduleId] = @SCHEDULE_BATCH_ID
					AND BSE.[Status] IN ('PENDING', 'REGISTERED_ON_REDIS', 'BATCH_CREATED', 'BATCH_STARTED')

			-- SI TENEMOS 0 EJECUCIONES NO TERMINADAS, DAMOS POR FINALIZADA LA AGENDA
			IF @SCHEDULE_EXECUTIONS = 0
				UPDATE [dbo].[BatchSchedule]
					SET [Status] = 'FINISHED',
						[LastModifiedByUserId] = 'system',
						[LastModifiedDate] = GETUTCDATE()
					WHERE [VCC] = @VCC 
						AND [ID] = @SCHEDULE_BATCH_ID
		END
	END
	ELSE IF @BatchTypeName = 'STUDY'
	BEGIN 
		UPDATE [dbo].[Study] 
			SET [StatusDescription] = CASE WHEN [Percentage] = 1 AND  ISNULL([Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN [Percentage] = 1 AND  ISNULL([Error],0) = 0 THEN 'COMPLETED' END
			WHERE [VCC] = @VCC
				AND [Name] = @BatchTypeId
				AND [Percentage] = 1
	END
	ELSE IF @BatchTypeName = 'EVALUATION_PLAN'
	BEGIN 
		UPDATE [dbo].[EvaluationPlan] 
			SET [StatusDescription] = CASE WHEN [Percentage] = 1 AND  ISNULL([Error], 0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN [Percentage] = 1 AND  ISNULL([Error], 0) = 0 THEN 'COMPLETED' END 
			WHERE [Instance] = @VCC
				AND [ID] = @BatchTypeId
				AND [Percentage] = 1
				AND ([Status] = 3 OR [Status] = 5 OR [Status] = 7)
	END

	SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetInteractionsResult]...';


GO
ALTER PROCEDURE [dbo].[GetInteractionsResult]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50),
	@Channels			VARCHAR(100)
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- SELECCIONAMOS UN QUERY DEPENDIENDO DEL CANAL
	IF @Channels = 'CALL' 
	BEGIN
		-- HACEMOS LA BUSQUEDA PARA LAS INTERACCIONES SINCRONAS(CALL)
		SELECT 'CALL'																'interactionType', 
				COUNT(DISTINCT CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]))		'quantity',
				ISNULL(SUM(A.[DurationTime]), 0)									'timeQuantity',
				COUNT(DISTINCT A.[ID])												'totalSyncInteractions',
				SUM(
					CASE WHEN A.[IsCancel] = 1 THEN A.[DurationTime] ELSE 0 END
				)																	'alreadyTranscribedTime',
				SUM(
					CASE WHEN A.[IsProcess] IS NULL THEN A.[DurationTime] ELSE 0 END 
				)																	'notTranscribedDurationTime',
				SUM(
					CASE WHEN (A.[IsProcess] = 1 AND A.[IsTranscribed] IS NULL AND A.[IsCancel] IS NULL)
					THEN A.[DurationTime] ELSE 0 END
				)																	'inProcessTime',
				SUM(
					CASE WHEN A.[IsCancel] = 1 THEN A.[DurationTime] ELSE 0 END
				)																	'cancelledTime'
				--COUNT(DISTINCT A.[ID])												'timeQuantity'
			FROM [dbo].[Process] P (NOLOCK)
			LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK)
				ON PA.[ProcessId] = P.[Name]
			LEFT JOIN [dbo].[Audio] A (NOLOCK)
				ON A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE P.[VCC] = @VCC
				AND P.[Name] = @ProcessId
				AND A.[ID] IS NOT NULL

	END
	ELSE 
	BEGIN
		-- HACEMOS LA BUSQUEDA PARA LAS INTERACCIONES SINCRONAS(OTROS CANALES)
		SELECT PAI.[InteractionType]												'interactionType',
				COUNT(DISTINCT CONCAT(PAI.[InteractionId], PAI.[EndDate]))			'totalInteractionDetails',
				COUNT(DISTINCT PAI.[InteractionId])									'totalInteractions'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK) 
			WHERE PAI.[VCC] = @VCC 
				AND PAI.[ProcessId] = @ProcessId
				AND PAI.[InteractionType] IN (SELECT VALUE FROM [dbo].[split](@Channels, ','))
			GROUP BY PAI.[InteractionType]
	END

	/* -- ESTA FUNCION RETORNA SOLO EL TOTAL Y TIEMPO DE LOS AUDIOS QUE NO HAN SIDO TRANSCRITOS
	SELECT
		COUNT(PA.[AudioId])						'interactionsTotal',
		ISNULL(SUM(A.[DurationTime]), 0)		'timeInSeconds'
	FROM ProcessAudio PA (NOLOCK)
	INNER JOIN Audio A (NOLOCK) 
		ON CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part]) = CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) 
			AND PA.[VCC] = A.[VCC]
	WHERE
		PA.[VCC] = @VCC
		AND [ProcessId] = @ProcessId
		AND A.[IsTranscribed] IS NULL
	*/
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveProcess]...';


GO

ALTER PROCEDURE [dbo].[SaveProcess] (
	@VCC Varchar(50) = NULL,
	@Name Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@ClientId Varchar(50) = NULL,
	@Type VARCHAR(50),
	@Status Varchar(50) = NULL,
	@StartDate Datetime = NULL,
	@EndDate Datetime = NULL,
	@MinDurationTime Numeric(18, 2) = NULL,
	@MaxDurationTime Numeric(18, 2) = NULL,
	@Language VARCHAR(25) = NULL,
	@DictionaryId VARCHAR(50) = NULL,
	@Environment Varchar(50) = NULL,
	@QueryId Varchar(50) = NULL,
	@QueryDataId Varchar(50) = NULL,
	@QueryDataIdDate Datetime = NULL,
	@BatchScheduleId VARCHAR(50) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [Process]
	SET [Description] = @Description,
		[ClientId] = @ClientId,
		[Status] = @Status,
		[Type] = @Type,
		[StartDate] = @StartDate,
		[EndDate] = @EndDate,
		[MinDurationTime] = @MinDurationTime,
		[MaxDurationTime] = @MaxDurationTime,
		[Language] = @Language,
		[DictionaryId] = @DictionaryId,
		[Environment] = @Environment,
		[QueryId] = @QueryId,
		[QueryDataId] = @QueryDataId,
		[QueryDataIdDate] = @QueryDataIdDate,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Process] (
			[VCC], [Name], [Description],
			[ClientId], [Status], [Type], [StartDate],
			[EndDate], [MinDurationTime], [MaxDurationTime], 
			[Language], [DictionaryId], [Environment], 
			[QueryId], [QueryDataId], [QueryDataIdDate],
			[BatchScheduleId], 
			[CreatedDate], [CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @Name, @Description,
			@ClientId, @Status, @Type, @StartDate,
			@EndDate, @MinDurationTime, @MaxDurationTime, 
			@Language, @DictionaryId, @Environment, 
			@QueryId, @QueryDataId, @QueryDataIdDate, 
			@BatchScheduleId,
			@CreatedDate, @CreatedByUserId, @LastModifiedDate, 
			@LastModifiedByUserId, GETUTCDATE()
		)
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveProcessFilter]...';


GO

ALTER PROCEDURE [dbo].[SaveProcessFilter] (
	@VCC Varchar(50) = NULL, 				@ProcessId Varchar(50) = NULL,				@Key Varchar(50) = NULL,
	@Value Varchar(250) = NULL,				@CreatedDate Datetime = NULL,				@CreatedByUserId Varchar(50) = NULL,		
	@LastModifiedDate Datetime = NULL,		@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [ProcessFilter]
	SET [Key] = @Key,
		[Value] = @Value,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [ProcessId] = @ProcessId
	AND [Key] = @Key
	AND [Value] = @Value

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [ProcessFilter] (
			[VCC], [ProcessId], [Key],
			[Value], [CreatedDate], 
			[CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @ProcessId, @Key,
			@Value, @CreatedDate,
			@CreatedByUserId, @LastModifiedDate, 
			@LastModifiedByUserId, GETUTCDATE()
		)
	END

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetFinishedBatch]...';


GO
ALTER PROCEDURE [dbo].[GetFinishedBatch] 
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE RETORNAR LOS BATCH QUE HAN SIDO FINALIZADOS HACE MAS DE 5 MINUTOS
	SET NOCOUNT ON

	SELECT B.[VCC]				'vcc',
		B.[BatchTypeName]		'batchTypeName',
		B.[BatchTypeId]			'batchTypeId',
		B.[ClosedDate]			'closedDate'
	FROM [dbo].[Batch] B (NOLOCK)
	WHERE B.[IsFinished] = 1 
		AND B.[FinishReported] = 0
		AND B.[LastModifiedDate] < DATEADD(MINUTE, -5, GETUTCDATE())
		AND B.[CreatedDate] > DATEADD(DAY, -5, GETUTCDATE())
		--AND DATEADD(MINUTE, 5, B.[LastModifiedDate]) < GETUTCDATE()
		--AND B.[CreatedDate] > DATEADD(DAY, -5, GETUTCDATE())

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcesses]...';


GO
-- GetProcesses 'inconcert', 'name', '', NULL, NULL, 'SPEECH'
ALTER PROCEDURE [dbo].[GetProcesses]
(
	@VCC						VARCHAR(50) = NULL,
	@SearchCriteria				VARCHAR(50) = NULL,
	@SearchExpression			VARCHAR(50) = NULL,
	@StartDate					DATETIME,
	@EndDate					DATETIME,
	@Type						VARCHAR(50)
)
AS
BEGIN
	DECLARE @SQL NVARCHAR(MAX)
	SET @SQL = '
	SET NOCOUNT ON

	SELECT
		[VCC]																				''vcc'',
		[Name]																				''name'',
		[Description]																		''description'',
		[ClientId]																			''clientId'',
		[Percentage]																		''percentage'',
		[StatusDescription]																	''statusDescription'',
		(CASE WHEN [Status] IS NULL THEN ''UNKNOWN'' ELSE [Status] END)						''status'',
		[StartDate]																			''startDate'',
		[EndDate]																			''endDate'',
		[MinDurationTime]																	''minDurationTime'',
		[MaxDurationTime]																	''maxDurationTime'',
		[Language]																			''language'',
		[Environment]																		''environment'',
		[CreatedDate]																		''createdDate'',
		[CreatedByUserId]																	''createdByUserId'',
		[LastModifiedDate]																	''lastModifiedDate'',
		[LastModifiedByUserId]																''lastModifiedByUserId''
	FROM [Process] (NOLOCK)
	WHERE [VCC] = ''' + @VCC + '''
	AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
	AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
	AND ISNULL([ClientId], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''clientId'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
	AND ISNULL([Status], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''status'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
	AND ISNULL([Environment], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''environment'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'

	IF(@StartDate IS NOT NULL AND @EndDate IS NOT NULL)
	BEGIN
		SET @SQL += '
			AND [CreatedDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
		'
	END
	SET @SQL += '
	AND [Type] = ''' + @Type + '''
	ORDER BY [Status] desc, [CreatedDate] desc 

	SET NOCOUNT OFF
	'
	EXEC(@SQL)
END
GO
PRINT N'Creando [dbo].[DeleteBatchSchedule]...';


GO
CREATE PROCEDURE [dbo].[DeleteBatchSchedule] (
	@VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- ELIMINAMOS LA AGENDA
	DELETE [dbo].[BatchSchedule] 
		WHERE [VCC] = @VCC
			AND [ID] = @ID

	-- ELIMINAMOS LAS EJECUCIONES
	DELETE [dbo].[BatchScheduleExecution] 
		WHERE [VCC] = @VCC
			AND [BatchScheduleId] = @ID
    
	-- RETORNAMOS EL RESULTADO
	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[DeleteBatchScheduleExecution]...';


GO

CREATE PROCEDURE [dbo].[DeleteBatchScheduleExecution] (
	@VCC VARCHAR(50) = NULL, 
	@ID VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- ELIMINAMOS LA EJECUCION
	DELETE [BatchScheduleExecution] 
		WHERE [VCC] = @VCC
			AND [Id] = @ID

    -- RETORNAMOS EL RESULTADO
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetBatchScheduleById]...';


GO
CREATE PROCEDURE [dbo].[GetBatchScheduleById] (
	@VCC VARCHAR(50) = NULL, 
	@Id VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT BS.[Id]								'id',
			BS.[BatchType]						'batchType',
			BS.[Frequency]						'frequency',
			BS.[Weekday]						'weekday',
			BS.[Monthday]						'monthday',
			BS.[DaysInterval]					'daysInterval',
			BS.[HoursInterval]					'hoursInterval',
			BS.[StartDate]						'startDate',
			BS.[EndDate]						'endDate',
			BS.[FirstExecutionDate]				'firstExecutionDate',
			BS.[LastExecutionDate]				'lastExecutionDate',
			BS.[FinalExecutionDate]				'finalExecutionDate',
			BS.[Status]							'status',
			BS.[CreatedDate]					'createdDate',
			BS.[CreatedByUserId]				'createdByUserId',
			BS.[LastModifiedDate]				'lastModifiedDate',
			BS.[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[BatchSchedule] BS (NOLOCK)
		WHERE BS.[VCC] = @VCC
			AND BS.[Id] = @Id

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetBatchScheduleByName]...';


GO
CREATE PROCEDURE [dbo].[GetBatchScheduleByName] (
	@VCC VARCHAR(50) = NULL, 
	@Name VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT BS.[Id]								'id',
			BS.[BatchType]						'batchType',
			BS.[Frequency]						'frequency',
			BS.[Weekday]						'weekday',
			BS.[Monthday]						'monthday',
			BS.[DaysInterval]					'daysInterval',
			BS.[HoursInterval]					'hoursInterval',
			BS.[StartDate]						'startDate',
			BS.[EndDate]						'endDate',
			BS.[FirstExecutionDate]				'firstExecutionDate',
			BS.[LastExecutionDate]				'lastExecutionDate',
			BS.[FinalExecutionDate]				'finalExecutionDate',
			BS.[CreatedDate]					'createdDate',
			BS.[CreatedByUserId]				'createdByUserId',
			BS.[LastModifiedDate]				'lastModifiedDate',
			BS.[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[BatchSchedule] BS (NOLOCK)
		WHERE BS.[VCC] = @VCC
			AND BS.[Id] = @Name

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetBatchScheduleExecutionsByBatchType]...';


GO
CREATE PROCEDURE [dbo].[GetBatchScheduleExecutionsByBatchType] (
	@VCC VARCHAR(50) = NULL, 
	@BatchScheduleId VARCHAR(50) = NULL,
	@BatchType VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- SI NO RECIBIMOS EL TIPO, LOS CONSULTAMOS A LA TABLA DE AGENDAS
	IF @BatchType IS NULL
		SELECT @BatchType  = BS.[BatchType] 
			FROM [dbo].[BatchSchedule] BS (NOLOCK)
			WHERE BS.[VCC] = @VCC 
				AND BS.[Id] = @BatchScheduleId

	-- EJECUTAMOS LA CONSULTA SEGUN EL TIPO DE BATCH
	IF @BatchType = 'TRANSCRIPTION'
	BEGIN
		-- HACEMOS LA CONSULTA DE BATCHES CORRESPONDIENTES A LA AGENDA
		SELECT BSE.[VCC]										'vcc',
					BSE.[Id]									'id', 
					BSE.[BatchScheduleId]						'batchScheduleId', 
					BSE.[BatchId]								'batchId', 
					BSE.[ExecutionDate]							'executionDate', 
					BSE.[Order]									'order', 
					BSE.[Status]								'status', 
					--BSE.[CreatedDate]							'createdDate',
					--BSE.[CreatedByUserId]						'createdByUserId',
					--BSE.[LastModifiedDate]						'lastModifiedDate',
					--BSE.[LastModifiedByUserId]					'lastModifiedByUserId',
					P.[Name]									'name',
					P.[Description]								'description',
					P.[ClientId]								'clientId',
					P.[Percentage]								'percentage',
					P.[StatusDescription]						'statusDescription',
					(
						CASE WHEN P.[Status] IS NULL 
							THEN 'UNKNOWN' 
							ELSE P.[Status] END
					)											'batchStatus',
					P.[StartDate]								'startDate',
					P.[EndDate]									'endDate',
					P.[MinDurationTime]							'minDurationTime',
					P.[MaxDurationTime]							'maxDurationTime',
					P.[Language]								'language',
					P.[Environment]								'environment',
					P.[CreatedDate]								'createdDate',
					P.[CreatedByUserId]							'createdByUserId',
					P.[LastModifiedDate]						'lastModifiedDate',
					P.[LastModifiedByUserId]					'lastModifiedByUserId'
			FROM [dbo].[BatchScheduleExecution] BSE (NOLOCK)
			LEFT JOIN [dbo].[Process] P (NOLOCK)
				ON P.[VCC] = BSE.[VCC]
					AND P.[Name] = BSE.[BatchId]
			WHERE BSE.[VCC] = @VCC
				AND BSE.[BatchScheduleId] = @BatchScheduleId
				AND BSE.[Status] <> 'PENDING'
			ORDER BY BSE.[ExecutionDate] DESC
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetBatchScheduleExecutionsByCriteria]...';


GO
CREATE PROCEDURE [dbo].[GetBatchScheduleExecutionsByCriteria] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria VARCHAR(50) = NULL,
	@SearchExpression VARCHAR(500) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @SQL VARCHAR(MAX) = ''
	-- DECLARAMOS CADENAS PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = ''

	SET @SQL_SELECT = '
		SELECT BSE.[VCC]									''vcc'',
				BSE.[Id]									''id'', 
				BSE.[BatchScheduleId]						''batchScheduleId'', 
				BSE.[BatchId]								''batchId'', 
				BSE.[ExecutionDate]							''executionDate'', 
				BSE.[Order]									''order'', 
				BSE.[Status]								''status'', 
				BSE.[CreatedDate]							''createdDate'',
				BSE.[CreatedByUserId]						''createdByUserId'',
				BSE.[LastModifiedDate]						''lastModifiedDate'',
				BSE.[LastModifiedByUserId]					''lastModifiedByUserId'',
				RN = ROW_NUMBER() OVER(PARTITION BY BSE.[VCC],
													BSE.[BatchScheduleId]
										ORDER BY BSE.[ExecutionDate] DESC) '

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM [dbo].[BatchScheduleExecution] BSE (NOLOCK) '

	-- ARMAMOS LA PARTE BASE DE FILTROS
	SET @FILTERS_FIXED_PART = '
			WHERE BSE.[Id] IS NOT NULL '

	-- 
	IF @VCC IS NOT NULL
		SET @FILTERS_OPTIONAL_PART += '
				AND BSE.[VCC] = ''' + @VCC + ''' '

	/* DEPRECATED
	-- CUANDO SE HACE BUSQUEDA POR ULTIMA EJECUCIONES
	IF @SearchCriteria = 'ALREADY_EXECUTED_BY_BS_ID'
		SET @FILTERS_OPTIONAL_PART += '
				AND BSE.[BatchScheduleId] = ''' + @SearchExpression + ''' 
				AND BSE.[Status] <> ''PENDING'' '
	*/
	
	-- CUANDO SE HACE BUSQUEDA POR NO EJECUTADAS
	IF @SearchCriteria = 'NO_EXECUTED_BY_SCHEDULE_ID'
	SET @FILTERS_OPTIONAL_PART += '
				AND BSE.[BatchScheduleId] IN (SELECT Value FROM [dbo].[split](''' + @SearchExpression + ''','','')) 
				AND BSE.[Status] IN (''PENDING'', ''REGISTERED_ON_REDIS'') '

	-- CUANDO SE HACE BUSQUEDA MULTIPLE POR IDS
	IF @SearchCriteria = 'NOT_CREATED_BY_BS_ID'
		SET @FILTERS_OPTIONAL_PART += '
				AND BSE.[BatchScheduleId] IN (SELECT Value FROM [dbo].[split](''' + @SearchExpression + ''','',''))
				AND BSE.[BatchId] IS NULL 
				AND BSE.[Status] NOT LIKE ''CANCELLED_%'' '

	-- CUANDO SE HACE BUSQUEDA POR ULTIMA EJECUCIONES
	IF @SearchCriteria = 'LAST_CREATED_EXECUTIONS'
	SET @FILTERS_OPTIONAL_PART += '
				AND BSE.[BatchScheduleId] IN (SELECT Value FROM [dbo].[split](''' + @SearchExpression + ''','','')) '
	
	-- EL FILTRO POR DEFECTO
	IF @SQL_EXTRA IS NULL OR @SQL_EXTRA  = ''
		SET @SQL_EXTRA += '
			ORDER BY BSE.[ExecutionDate] ASC, BSE.[BatchScheduleId] '

	
	
	-- CUANDO SE HACE BUSQUEDA POR ULTIMA EJECUCIONES
	IF @SearchCriteria = 'LAST_CREATED_EXECUTIONS'
	BEGIN
		-- UNIMOS LAS PARTES DEL QUERY
		SET @SQL_SELECT += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART
		
		--
		SET @SQL = ';WITH CTE AS (' + @SQL_SELECT + ')'

	
		SET @SQL += 'SELECT * FROM CTE BSE WHERE RN = 1 ORDER BY BSE.[ExecutionDate] DESC, BSE.[BatchScheduleId] '
	END
	ELSE
	BEGIN
		-- UNIMOS LAS PARTES DEL QUERY
		SET @SQL_SELECT += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA
		SET @SQL += @SQL_SELECT
	END

	-- EJECUTAMOS LA QUERY
	EXEC (@SQL)

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetBatchSchedules]...';


GO
CREATE PROCEDURE [dbo].[GetBatchSchedules] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria VARCHAR(50) = NULL,
	@SearchExpression VARCHAR(500) = NULL,
	@ExtendedContent BIT = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @SQL NVARCHAR(MAX)
	SET @SQL = '
		SET NOCOUNT ON
			
		SELECT BS.[VCC]									''vcc'',
				BS.[Id]									''id'',
				BS.[BatchType]							''batchType'',
				BS.[Frequency]							''frequency'',
				BS.[Weekday]							''weekday'',
				BS.[Monthday]							''monthday'',
				BS.[DaysInterval]						''daysInterval'',
				BS.[HoursInterval]						''hoursInterval'',
				BS.[StartDate]							''startDate'',
				BS.[EndDate]							''endDate'',
				BS.[FirstExecutionDate]					''firstExecutionDate'',
				BS.[LastExecutionDate]					''lastExecutionDate'',
				BS.[FinalExecutionDate]					''finalExecutionDate'', '

	IF @ExtendedContent = 1
		SET @SQL += '
				-- BS.[ExecutionList]						''executionList'',
				BS.[BatchData]							''batchData'', 
				BS.[ProcessFiltersId]					''processFiltersId'', '
				
	SET @SQL += '
				BS.[CreatedDate]						''createdDate'',
				BS.[CreatedByUserId]					''createdByUserId'',
				BS.[LastModifiedDate]					''lastModifiedDate'',
				BS.[LastModifiedByUserId]				''lastModifiedByUserId''
			FROM [dbo].[BatchSchedule] BS (NOLOCK)
			WHERE BS.[Id] IS NOT NULL '

	IF @VCC IS NOT NULL
		SET @SQL += '
				AND BS.[VCC] = ''' + @VCC + ''' '

	IF @SearchCriteria = 'NAME'
		SET @SQL += '
				AND BS.[Id] = ''' + @SearchExpression + ''' '

	IF @SearchCriteria = 'STATUS'
		SET @SQL += '
				AND BS.[Status] IN (SELECT Value FROM [dbo].[split](''' + @SearchExpression + ''','','')) '


	--select * FROM [dbo].[BatchSchedule] BS (NOLOCK)
	SET @SQL += '
			ORDER BY BS.[CreatedDate] DESC, BS.[Id]

		SET NOCOUNT OFF'

	-- EJECUTAMOS LA QUERY
	EXEC (@SQL)

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetBatchSchedulesSummary]...';


GO
CREATE PROCEDURE [dbo].[GetBatchSchedulesSummary] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria VARCHAR(50) = NULL,
	@SearchExpression VARCHAR(500) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- BUSCAMOS LAS ULTIMAS EJECUCIONES DE CADA AGENDA
	;WITH CTE_LAST_VALID_EXECUTIONS AS (
		SELECT BSE.[VCC],
				BSE.[BatchScheduleId],
				BSE.[BatchId],
				BSE.[ExecutionDate],
				BSE.[Status],
				RN = ROW_NUMBER() OVER(PARTITION BY BSE.[VCC],
													BSE.[BatchScheduleId]
										ORDER BY BSE.[ExecutionDate] DESC)
			FROM [dbo].[BatchSchedule] BS (NOLOCK)
			INNER JOIN [dbo].[BatchScheduleExecution] BSE (NOLOCK)
				ON BSE.[VCC] = BS.[VCC]
					AND BSE.[BatchScheduleId] = BS.[Id]
			WHERE BS.[VCC] = @VCC
				AND BS.[Status] IN ('CREATED', 'RUNNING')
				AND BSE.[Status] NOT IN ('PENDING', 'REGISTERED_ON_REDIS', 'CANCELLED_BY_NO_INTERACTIONS_FOUND')
				-- AND BSE.[Status] = 'COMPLETED'
	),
	CTE_LAST_EXECUTIONS AS (
		SELECT CTE_VE.[VCC], 
				CTE_VE.[BatchScheduleId], 
				CTE_VE.[BatchId], 
				CASE WHEN CTE_VE.[Status] = 'REGISTERED_ON_REDIS' THEN NULL ELSE CTE_VE.[ExecutionDate] END		'LastExecutionDate', 
				CTE_VE.[Status]
			FROM CTE_LAST_VALID_EXECUTIONS CTE_VE
			WHERE CTE_VE.[RN] = 1
	),
	CTE_NEXT_VALID_EXECUTIONS AS (
		SELECT BSE.[VCC],
				BSE.[BatchScheduleId],
				BSE.[BatchId],
				BSE.[ExecutionDate],
				BSE.[Status],
				CTE_LA.[LastExecutionDate],
				RN = ROW_NUMBER() OVER(PARTITION BY BSE.[VCC],
													BSE.[BatchScheduleId]
										ORDER BY BSE.[ExecutionDate] ASC)
			FROM [dbo].[BatchSchedule] BS (NOLOCK)
			INNER JOIN [dbo].[BatchScheduleExecution] BSE (NOLOCK)
				ON BSE.[VCC] = BS.[VCC]
					AND BSE.[BatchScheduleId] = BS.[Id]
			INNER JOIN CTE_LAST_EXECUTIONS CTE_LA
				ON CTE_LA.[VCC] = BS.[VCC]
					AND CTE_LA.[BatchScheduleId] = BS.[Id]
			WHERE BS.[VCC] = @VCC
				AND BSE.[Status] = 'PENDING'
	),
	CTE_NEXT_EXECUTIONS AS (
		SELECT CTE_VE.[VCC], 
				CTE_VE.[BatchScheduleId], 
				CTE_VE.[BatchId], 
				CTE_VE.[ExecutionDate]																			'NextExecutionDate', 
				CTE_VE.[LastExecutionDate]																		'LastExecutionDate', 
				CTE_VE.[Status]
			FROM CTE_NEXT_VALID_EXECUTIONS CTE_VE
			WHERE CTE_VE.[RN] = 1
	),
	CTE_SUMMARY AS (
		SELECT CTE_NE.*,
				COUNT(BSE.[Id])																					'Total',
				COUNT(IIF(BSE.[STATUS] LIKE 'REGISTERED_%', 1, NULL))											'Preparing',
				COUNT(IIF(BSE.[STATUS] LIKE '%_CREATED' OR BSE.[STATUS] LIKE '%_STARTED', 1, NULL))				'Running',
				COUNT(IIF(BSE.[STATUS] LIKE 'CANCELLED_%', 1, NULL))											'Cancelled',
				COUNT(IIF(BSE.[STATUS] LIKE 'COMPLETED%' OR BSE.[STATUS] = 'FAILED', 1, NULL))					'Finished',
				COUNT(IIF(BSE.[STATUS] = 'COMPLETED', 1, NULL))													'Succeed',
				COUNT(IIF(BSE.[STATUS] LIKE '%_WITH_ERRORS', 1, NULL))											'Error',
				COUNT(IIF(BSE.[STATUS] LIKE '%FAILED%', 1, NULL))												'Failed'
			FROM [dbo].[BatchSchedule] BS (NOLOCK)
			INNER JOIN [dbo].[BatchScheduleExecution] BSE (NOLOCK)
				ON BSE.[VCC] = BS.[VCC]
					AND BSE.[BatchScheduleId] = BS.[Id]
			INNER JOIN CTE_NEXT_EXECUTIONS CTE_NE 
				ON CTE_NE.[VCC] = BS.[VCC]
					AND CTE_NE.[BatchScheduleId] = BS.[Id]
			WHERE BS.[VCC] = 'collegeocc'
				AND BS.[Status] IN ('CREATED', 'RUNNING')
				AND BSE.[Status] <> 'PENDING'
			GROUP BY CTE_NE.[VCC], CTE_NE.[BatchScheduleId], CTE_NE.[BatchId], CTE_NE.[NextExecutionDate], CTE_NE.[LastExecutionDate], CTE_NE.[Status]
	)-- select * from CTE_SUMMARY
		SELECT BS.[VCC]																	'vcc',
				BS.[Id]																	'id',
				BS.[BatchType]															'batchType',
				BS.[Frequency]															'frequency',
				--BS.[Weekday]															'weekday',
				--BS.[Monthday]															'monthday',
				BS.[DaysInterval]														'daysInterval',
				BS.[HoursInterval]														'hoursInterval',
				BS.[StartDate]															'startDate',
				BS.[EndDate]															'endDate',
				BS.[FirstExecutionDate]													'firstExecutionDate',
				BS.[Status]																'status',
				--BS.[LastExecutionDate]													'lastExecutionDate',
				-- BS.[FinalExecutionDate]													'finalExecutionDate', 
				ISNULL(CTE_S.[Total], 0)												'total',
				ISNULL(CTE_S.[Preparing], 0)											'preparing',
				ISNULL(CTE_S.[Running], 0)												'running',
				ISNULL(CTE_S.[Cancelled], 0)											'cancelled',
				ISNULL(CTE_S.[Finished], 0)												'finished',
				ISNULL(CTE_S.[Succeed], 0)												'succeed',
				ISNULL(CTE_S.[Error], 0)												'error',
				ISNULL(CTE_S.[Failed], 0)												'failed',
				CTE_S.[LastExecutionDate]												'lastExecutionDate',
				CTE_S.[Status]															'lastExecutionStatus',
				CTE_S.[NextExecutionDate]												'nextExecutionDate',
				BS.[CreatedDate]														'createdDate',
				BS.[CreatedByUserId]													'createdByUserId',
				BS.[LastModifiedDate]													'lastModifiedDate',
				BS.[LastModifiedByUserId]												'lastModifiedByUserId'
			FROM [dbo].[BatchSchedule] BS (NOLOCK)
			LEFT JOIN CTE_SUMMARY CTE_S
				ON CTE_S.[VCC] = BS.[VCC]
					AND CTE_S.[BatchScheduleId] = BS.[Id]
			LEFT JOIN [dbo].[Process] P (NOLOCK)
				ON BS.[BatchType] = 'TRANSCRIPTION'
					AND P.[VCC] = CTE_S.[VCC]
					AND P.[Name] = CTE_S.[BatchId]
			LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON BS.[BatchType] = 'EVALUATION_PLAN'
					AND EP.[Instance] = CTE_S.[VCC]
					AND EP.[ID] = CTE_S.[BatchId]
			WHERE BS.[VCC] = @VCC
				AND ISNULL(BS.[Id], '') LIKE CASE WHEN @SearchCriteria = 'NAME' THEN '%' + @SearchExpression + '%' ELSE '%' END

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveBatchSchedule]...';


GO
CREATE PROCEDURE [dbo].[SaveBatchSchedule] (
	@VCC VARCHAR(50) = NULL,
	@Id VARCHAR(50) = NULL,
	@BatchType VARCHAR(50) = NULL, -- TRANSCRIPTION/STUDY(?)/EVALUATION_PLAN
	@Frequency VARCHAR(50) = NULL,
	@Weekday INT = NULL,
	@Monthday INT = NULL,
	@DaysInterval INT = NULL,
	@HoursInterval INT = NULL,
	@ExecutionHour VARCHAR(50) = NULL,
	@FirstExecutionDate DATETIME = NULL,
	@StartDate DATETIME = NULL,
	@EndDate DATETIME = NULL,
	@BatchData VARCHAR(MAX) = NULL,
	@ProcessFiltersId VARCHAR(50) = NULL,
	@Status VARCHAR(50) = NULL, -- CREATED/RUNNING/PAUSED/FINISHED
	@UserId VARCHAR(50) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE REGISTRAR LOS ERRORES QUE PUEDEN OCURRIR DURANTE LA EJECUCION DE LAS COLAS
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- VALIDAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
		IF @VCC IS NULL 
			OR @Id IS NULL 
			OR @Frequency IS NULL 
			OR @StartDate IS NULL 
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABASE_ERROR_MISSING_PARAMETERS', 16, 16)

		--
		UPDATE [dbo].[BatchSchedule]
			SET [LastExecutionDate] = NULL,
				[Status] = ISNULL(@Status, [Status]),
				[LastModifiedDate] = GETUTCDATE(),
				[LastModifiedByUserId] = @UserId,
				[TimeStamp] = GETUTCDATE()
			WHERE [VCC] = @VCC
				AND [Id] = @Id
				AND [BatchType] = @BatchType
		
		-- SI NO SE ACTUALIZO NINGUN REGISTRO, LO INSERTAMOS
		IF @@ROWCOUNT = 0
		BEGIN
			--select * from BatchSchedule (nolock)
			-- INSERTAMOS EL REGISTRO EN LA TABLA DE ERROR
			INSERT INTO [dbo].[BatchSchedule] (
					[VCC], [Id], [BatchType], [Frequency], [Weekday],
					[Monthday], [DaysInterval], [HoursInterval], [StartDate], [EndDate],
					[FirstExecutionDate], [LastExecutionDate], [FinalExecutionDate], [BatchData], [ProcessFiltersId],
					[Status], [CreatedDate], [CreatedByUserId], [TimeStamp]
				) VALUES (
					@VCC, @Id, @BatchType, @Frequency, @Weekday,
					@Monthday, @DaysInterval, @HoursInterval, @StartDate, @EndDate,
					@FirstExecutionDate, NULL, NULL, @BatchData, @ProcessFiltersId, 
					'CREATED', GETUTCDATE(), @UserId, GETUTCDATE()
				)
		END

		SELECT 1 AS 'result'
    
	END TRY
    BEGIN CATCH
        --IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveBatchScheduleExecution]...';


GO
CREATE PROCEDURE [dbo].[SaveBatchScheduleExecution] (
	@VCC VARCHAR(50) = NULL,
	@Id VARCHAR(50) = NULL,
	@BatchScheduleId VARCHAR(50) = NULL, 
	@BatchId VARCHAR(50) = NULL,
	@ExecutionDate DATETIME = NULL,
	@Order VARCHAR(50) = NULL,
	@Status VARCHAR(50) = NULL,
	@UserId VARCHAR(50) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE REGISTRAR LOS ERRORES QUE PUEDEN OCURRIR DURANTE LA EJECUCION DE LAS COLAS
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
		-- VALIDAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
		IF @VCC IS NULL 
			OR @Id IS NULL 
			OR @BatchScheduleId IS NULL 
			-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
			RAISERROR('DATABASE_ERROR_MISSING_PARAMETERS', 16, 16)

		--
		UPDATE [dbo].[BatchScheduleExecution]
			SET [BatchId] = @BatchId,
				[Status] = @Status,
				[LastModifiedDate] = GETUTCDATE(),
				[LastModifiedByUserId] = @UserId,
				[TimeStamp] = GETUTCDATE()
			WHERE [VCC] = @VCC
				AND [Id] = @Id

		-- SI NO SE ACTUALIZO NINGUN REGISTRO, LO INSERTAMOS
		IF @@ROWCOUNT = 0
		BEGIN
			--select * from BatchSchedule (nolock)
			-- INSERTAMOS EL REGISTRO EN LA TABLA DE ERROR
			INSERT INTO [dbo].[BatchScheduleExecution] (
					[VCC], [Id], [BatchScheduleId], [BatchId], [ExecutionDate], 
					[Order], [Status], [CreatedDate], [CreatedByUserId], [TimeStamp]
				) VALUES (
					@VCC, @Id, @BatchScheduleId, @BatchId, @ExecutionDate, 
					@Order, @Status, GETUTCDATE(), @UserId, GETUTCDATE()
				)
		END

		-- EN CASO EL STATUS SEA BATCH CREADO O INICIADO, ACTUALIZAMOS EL REGISTRO DE LA AGENDA
		IF @Status = 'REGISTERED_ON_REDIS' OR @Status = 'BATCH_CREATED' OR @Status = 'BATCH_STARTED'
			UPDATE BS 
				SET BS.[LastExecutionDate] = BSE.[ExecutionDate],
					BS.[Status] = 'RUNNING',
					BS.[LastModifiedDate] = GETUTCDATE(),
					BS.[LastModifiedByUserId] = @UserId,
					BS.[TimeStamp] = GETUTCDATE()
				FROM [dbo].[BatchSchedule] BS 
				INNER JOIN [dbo].[BatchScheduleExecution] BSE
					ON BSE.[VCC] = BS.[VCC]	
						AND BSE.[BatchScheduleId] = BS.[Id]
				WHERE BS.[VCC] = @VCC 
					AND BSE.[Id] = @Id
						

	END TRY
    BEGIN CATCH
        --IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcess]...';


GO
--exec [GetProcess] 'inconcert','test'
ALTER PROCEDURE [dbo].[GetProcess] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT P.[VCC]										'vcc',
			P.[Name]									'name',
			P.[Description]								'description',
			P.[ClientId]								'clientId',
			P.[Status]									'status',
			P.[Type]									'type',
			P.[StartDate]								'startDate',
			P.[EndDate]									'endDate',
			P.[MinDurationTime]							'minDurationTime',
			P.[MaxDurationTime]							'maxDurationTime',
			P.[Language]								'language',
			P.[DictionaryId]							'dictionaryId',
			IIF (
				P.[DictionaryId] IS NULL, 
				CONVERT(BIT, 0), 
				CONVERT(BIT, 1)
			)											'useDictionary',
			P.[Environment]								'environment',
			E.[Type]									'environmentType',
			P.[QueryId]									'queryId',
			P.[QueryDataId]								'queryDataId',
			P.[QueryDataIdDate]							'queryDataIdDate',
			P.[BatchScheduleId]							'batchScheduleId',
			P.[CreatedDate]								'createdDate',
			P.[CreatedByUserId]							'createdByUserId',
			P.[LastModifiedDate]						'lastModifiedDate',
			P.[LastModifiedByUserId]					'lastModifiedByUserId'
		FROM [dbo].[Process] P (NOLOCK)
		LEFT JOIN [dbo].[Environment] E (NOLOCK)
			ON E.[VCC] = P.[VCC]
				AND E.[Name] = P.[Environment]
		WHERE P.[VCC] = @VCC
			AND P.[Name] = @Name

	EXEC [GetProcessFilters] @VCC, @Name
	
	SET NOCOUNT OFF
END
GO
PRINT N'Actualizando [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Actualizando [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Actualizando [dbo].[DeleteProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteProcess]';


GO
PRINT N'Actualizando [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudio]';


GO
PRINT N'Actualizando [dbo].[GetAudioNavigatorInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudioNavigatorInteractions]';


GO
PRINT N'Actualizando [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetAudiosProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosProcess]';


GO
PRINT N'Actualizando [dbo].[GetBatchDetail]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetBatchDetail]';


GO
PRINT N'Actualizando [dbo].[GetCleanerData]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCleanerData]';


GO
PRINT N'Actualizando [dbo].[GetDictionaryUsage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetDictionaryUsage]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Actualizando [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Actualizando [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetProcessByName]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessByName]';


GO
PRINT N'Actualizando [dbo].[GetProcessByStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessByStatus]';


GO
PRINT N'Actualizando [dbo].[GetProcessEvaluationPlanTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessEvaluationPlanTask]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[GetProcessUsage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessUsage]';


GO
PRINT N'Actualizando [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Actualizando [dbo].[SaveBatchError]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveBatchError]';


GO
PRINT N'Actualizando [dbo].[SaveBatchStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveBatchStatus]';


GO
PRINT N'Actualizando [dbo].[SaveProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveProcessStatus]';


GO
PRINT N'Actualizando [dbo].[DeleteProcessFilter]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteProcessFilter]';


GO
PRINT N'Actualizando [dbo].[GetProcessChannelByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessChannelByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetProcessFilters]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessFilters]';


GO
PRINT N'Actualizando [dbo].[GetProcessTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessTask]';


GO
PRINT N'Actualización completada.';


GO
